# Sequel Pro dump
# Version 2210
# http://code.google.com/p/sequel-pro
#
# Host: 127.0.0.1 (MySQL 5.1.48)
# Database: thinksns
# Generation Time: 2010-12-13 14:54:18 +0800
# ************************************************************

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


# Dump of table ts_ad
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_ad`;

CREATE TABLE `ts_ad` (
  `ad_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `place` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0:中部 1:头部 2:左侧 3:右侧 4:底部',
  `content` text,
  `is_active` tinyint(1) NOT NULL DEFAULT '1',
  `is_closable` tinyint(1) NOT NULL DEFAULT '0',
  `ctime` int(11) DEFAULT NULL,
  `mtime` int(11) DEFAULT NULL,
  `display_order` smallint(2) NOT NULL DEFAULT '0',
  `display_type`  tinyint(1) UNSIGNED NULL DEFAULT 1,
  PRIMARY KEY (`ad_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_app
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_app`;

CREATE TABLE `ts_app` (
  `app_id` int(11) NOT NULL AUTO_INCREMENT,
  `app_name` varchar(255) NOT NULL,
  `app_alias` varchar(255) NOT NULL,
  `description` text,
  `version` varchar(255) DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0:关闭 1:默认 2:可选',
  `category` varchar(255) DEFAULT NULL,
  `release_date` varchar(255) DEFAULT NULL,
  `last_update_date` varchar(255) DEFAULT NULL,
  `host_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0：本地应用 1：远程应用',
  `app_entry` varchar(255) DEFAULT NULL,
  `icon_url` varchar(255) DEFAULT NULL,
  `large_icon_url` varchar(255) DEFAULT NULL,
  `admin_entry` varchar(255) DEFAULT NULL,
  `statistics_entry` varchar(255) DEFAULT NULL,
  `homepage_url` varchar(255) DEFAULT NULL,
  `sidebar_title` varchar(255) DEFAULT NULL,
  `sidebar_entry` varchar(255) DEFAULT NULL,
  `sidebar_icon_url` varchar(255) DEFAULT NULL,
  `sidebar_support_submenu` tinyint(1) NOT NULL DEFAULT '0',
  `sidebar_is_submenu_active` tinyint(1) NOT NULL DEFAULT '0',
  `author_name` varchar(255) DEFAULT NULL,
  `author_email` varchar(255) DEFAULT NULL,
  `author_homepage_url` varchar(255) DEFAULT NULL,
  `contributor_name` text,
  `display_order` smallint(5) NOT NULL DEFAULT '0',
  `ctime` int(11) DEFAULT NULL,
  PRIMARY KEY (`app_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


# Dump of table ts_area
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_area`;

CREATE TABLE `ts_area` (
  `area_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `pid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`area_id`),
  KEY `pid` (`pid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `ts_area` (`area_id`,`title`,`pid`)
VALUES
    (1,'北京',0),
    (2,'北京市',1),
    (3,'东城区',2),
    (4,'西城区',2),
    (5,'崇文区',2),
    (6,'宣武区',2),
    (7,'朝阳区',2),
    (8,'丰台区',2),
    (9,'石景山区',2),
    (10,'海淀区',2),
    (11,'门头沟区',2),
    (12,'房山区',2),
    (13,'通州区',2),
    (14,'顺义区',2),
    (15,'昌平区',2),
    (16,'大兴区',2),
    (17,'怀柔区',2),
    (18,'平谷区',2),
    (19,'密云县',2),
    (20,'延庆县',2),
    (21,'天津',0),
    (22,'天津市',21),
    (23,'和平区',22),
    (24,'河东区',22),
    (25,'河西区',22),
    (26,'南开区',22),
    (27,'河北区',22),
    (28,'红桥区',22),
    (29,'塘沽区',22),
    (30,'汉沽区',22),
    (31,'大港区',22),
    (32,'东丽区',22),
    (33,'西青区',22),
    (34,'津南区',22),
    (35,'北辰区',22),
    (36,'武清区',22),
    (37,'宝坻区',22),
    (38,'宁河县',22),
    (39,'静海县',22),
    (40,'蓟县',22),
    (41,'河北',0),
    (42,'石家庄市',41),
    (43,'长安区',42),
    (44,'桥东区',42),
    (45,'桥西区',42),
    (46,'新华区',42),
    (47,'井陉矿区',42),
    (48,'裕华区',42),
    (49,'井陉县',42),
    (50,'正定县',42),
    (51,'栾城县',42),
    (52,'行唐县',42),
    (53,'灵寿县',42),
    (54,'高邑县',42),
    (55,'深泽县',42),
    (56,'赞皇县',42),
    (57,'无极县',42),
    (58,'平山县',42),
    (59,'元氏县',42),
    (60,'赵县',42),
    (61,'辛集市',42),
    (62,'藁城市',42),
    (63,'晋州市',42),
    (64,'新乐市',42),
    (65,'鹿泉市',42),
    (66,'唐山市',41),
    (67,'路南区',66),
    (68,'路北区',66),
    (69,'古冶区',66),
    (70,'开平区',66),
    (71,'丰南区',66),
    (72,'丰润区',66),
    (73,'滦县',66),
    (74,'滦南县',66),
    (75,'乐亭县',66),
    (76,'迁西县',66),
    (77,'玉田县',66),
    (78,'唐海县',66),
    (79,'遵化市',66),
    (80,'迁安市',66),
    (81,'秦皇岛市',41),
    (82,'海港区',81),
    (83,'山海关区',81),
    (84,'北戴河区',81),
    (85,'青龙满族自治县',81),
    (86,'昌黎县',81),
    (87,'抚宁县',81),
    (88,'卢龙县',81),
    (89,'邯郸市',41),
    (90,'邯山区',89),
    (91,'丛台区',89),
    (92,'复兴区',89),
    (93,'峰峰矿区',89),
    (94,'邯郸县',89),
    (95,'临漳县',89),
    (96,'成安县',89),
    (97,'大名县',89),
    (98,'涉县',89),
    (99,'磁县',89),
    (100,'肥乡县',89),
    (101,'永年县',89),
    (102,'邱县',89),
    (103,'鸡泽县',89),
    (104,'广平县',89),
    (105,'馆陶县',89),
    (106,'魏县',89),
    (107,'曲周县',89),
    (108,'武安市',89),
    (109,'邢台市',41),
    (110,'桥东区',109),
    (111,'桥西区',109),
    (112,'邢台县',109),
    (113,'临城县',109),
    (114,'内丘县',109),
    (115,'柏乡县',109),
    (116,'隆尧县',109),
    (117,'任县',109),
    (118,'南和县',109),
    (119,'宁晋县',109),
    (120,'巨鹿县',109),
    (121,'新河县',109),
    (122,'广宗县',109),
    (123,'平乡县',109),
    (124,'威县',109),
    (125,'清河县',109),
    (126,'临西县',109),
    (127,'南宫市',109),
    (128,'沙河市',109),
    (129,'保定市',41),
    (130,'新市区',129),
    (131,'北市区',129),
    (132,'南市区',129),
    (133,'满城县',129),
    (134,'清苑县',129),
    (135,'涞水县',129),
    (136,'阜平县',129),
    (137,'徐水县',129),
    (138,'定兴县',129),
    (139,'唐县',129),
    (140,'高阳县',129),
    (141,'容城县',129),
    (142,'涞源县',129),
    (143,'望都县',129),
    (144,'安新县',129),
    (145,'易县',129),
    (146,'曲阳县',129),
    (147,'蠡县',129),
    (148,'顺平县',129),
    (149,'博野县',129),
    (150,'雄县',129),
    (151,'涿州市',129),
    (152,'定州市',129),
    (153,'安国市',129),
    (154,'高碑店市',129),
    (155,'张家口市',41),
    (156,'桥东区',155),
    (157,'桥西区',155),
    (158,'宣化区',155),
    (159,'下花园区',155),
    (160,'宣化县',155),
    (161,'张北县',155),
    (162,'康保县',155),
    (163,'沽源县',155),
    (164,'尚义县',155),
    (165,'蔚县',155),
    (166,'阳原县',155),
    (167,'怀安县',155),
    (168,'万全县',155),
    (169,'怀来县',155),
    (170,'涿鹿县',155),
    (171,'赤城县',155),
    (172,'崇礼县',155),
    (173,'承德市',41),
    (174,'双桥区',173),
    (175,'双滦区',173),
    (176,'鹰手营子矿区',173),
    (177,'承德县',173),
    (178,'兴隆县',173),
    (179,'平泉县',173),
    (180,'滦平县',173),
    (181,'隆化县',173),
    (182,'丰宁满族自治县',173),
    (183,'宽城满族自治县',173),
    (184,'围场满族蒙古族自治县',173),
    (185,'沧州市',41),
    (186,'新华区',185),
    (187,'运河区',185),
    (188,'沧县',185),
    (189,'青县',185),
    (190,'东光县',185),
    (191,'海兴县',185),
    (192,'盐山县',185),
    (193,'肃宁县',185),
    (194,'南皮县',185),
    (195,'吴桥县',185),
    (196,'献县',185),
    (197,'孟村回族自治县',185),
    (198,'泊头市',185),
    (199,'任丘市',185),
    (200,'黄骅市',185),
    (201,'河间市',185),
    (202,'廊坊市',41),
    (203,'安次区',202),
    (204,'广阳区',202),
    (205,'固安县',202),
    (206,'永清县',202),
    (207,'香河县',202),
    (208,'大城县',202),
    (209,'文安县',202),
    (210,'大厂回族自治县',202),
    (211,'霸州市',202),
    (212,'三河市',202),
    (213,'衡水市',41),
    (214,'桃城区',213),
    (215,'枣强县',213),
    (216,'武邑县',213),
    (217,'武强县',213),
    (218,'饶阳县',213),
    (219,'安平县',213),
    (220,'故城县',213),
    (221,'景县',213),
    (222,'阜城县',213),
    (223,'冀州市',213),
    (224,'深州市',213),
    (225,'山西',0),
    (226,'太原市',225),
    (227,'小店区',226),
    (228,'迎泽区',226),
    (229,'杏花岭区',226),
    (230,'尖草坪区',226),
    (231,'万柏林区',226),
    (232,'晋源区',226),
    (233,'清徐县',226),
    (234,'阳曲县',226),
    (235,'娄烦县',226),
    (236,'古交市',226),
    (237,'大同市',225),
    (238,'城区',237),
    (239,'矿区',237),
    (240,'南郊区',237),
    (241,'新荣区',237),
    (242,'阳高县',237),
    (243,'天镇县',237),
    (244,'广灵县',237),
    (245,'灵丘县',237),
    (246,'浑源县',237),
    (247,'左云县',237),
    (248,'大同县',237),
    (249,'阳泉市',225),
    (250,'城区',249),
    (251,'矿区',249),
    (252,'郊区',249),
    (253,'平定县',249),
    (254,'盂县',249),
    (255,'长治市',225),
    (256,'城区',255),
    (257,'郊区',255),
    (258,'长治县',255),
    (259,'襄垣县',255),
    (260,'屯留县',255),
    (261,'平顺县',255),
    (262,'黎城县',255),
    (263,'壶关县',255),
    (264,'长子县',255),
    (265,'武乡县',255),
    (266,'沁县',255),
    (267,'沁源县',255),
    (268,'潞城市',255),
    (269,'晋城市',225),
    (270,'城区',269),
    (271,'沁水县',269),
    (272,'阳城县',269),
    (273,'陵川县',269),
    (274,'泽州县',269),
    (275,'高平市',269),
    (276,'朔州市',225),
    (277,'朔城区',276),
    (278,'平鲁区',276),
    (279,'山阴县',276),
    (280,'应县',276),
    (281,'右玉县',276),
    (282,'怀仁县',276),
    (283,'晋中市',225),
    (284,'榆次区',283),
    (285,'榆社县',283),
    (286,'左权县',283),
    (287,'和顺县',283),
    (288,'昔阳县',283),
    (289,'寿阳县',283),
    (290,'太谷县',283),
    (291,'祁县',283),
    (292,'平遥县',283),
    (293,'灵石县',283),
    (294,'介休市',283),
    (295,'运城市',225),
    (296,'盐湖区',295),
    (297,'临猗县',295),
    (298,'万荣县',295),
    (299,'闻喜县',295),
    (300,'稷山县',295),
    (301,'新绛县',295),
    (302,'绛县',295),
    (303,'垣曲县',295),
    (304,'夏县',295),
    (305,'平陆县',295),
    (306,'芮城县',295),
    (307,'永济市',295),
    (308,'河津市',295),
    (309,'忻州市',225),
    (310,'忻府区',309),
    (311,'定襄县',309),
    (312,'五台县',309),
    (313,'代县',309),
    (314,'繁峙县',309),
    (315,'宁武县',309),
    (316,'静乐县',309),
    (317,'神池县',309),
    (318,'五寨县',309),
    (319,'岢岚县',309),
    (320,'河曲县',309),
    (321,'保德县',309),
    (322,'偏关县',309),
    (323,'原平市',309),
    (324,'临汾市',225),
    (325,'尧都区',324),
    (326,'曲沃县',324),
    (327,'翼城县',324),
    (328,'襄汾县',324),
    (329,'洪洞县',324),
    (330,'古县',324),
    (331,'安泽县',324),
    (332,'浮山县',324),
    (333,'吉县',324),
    (334,'乡宁县',324),
    (335,'大宁县',324),
    (336,'隰县',324),
    (337,'永和县',324),
    (338,'蒲县',324),
    (339,'汾西县',324),
    (340,'侯马市',324),
    (341,'霍州市',324),
    (342,'吕梁市',225),
    (343,'离石区',342),
    (344,'文水县',342),
    (345,'交城县',342),
    (346,'兴县',342),
    (347,'临县',342),
    (348,'柳林县',342),
    (349,'石楼县',342),
    (350,'岚县',342),
    (351,'方山县',342),
    (352,'中阳县',342),
    (353,'交口县',342),
    (354,'孝义市',342),
    (355,'汾阳市',342),
    (356,'内蒙古',0),
    (357,'呼和浩特市',356),
    (358,'新城区',357),
    (359,'回民区',357),
    (360,'玉泉区',357),
    (361,'赛罕区',357),
    (362,'土默特左旗',357),
    (363,'托克托县',357),
    (364,'和林格尔县',357),
    (365,'清水河县',357),
    (366,'武川县',357),
    (367,'包头市',356),
    (368,'东河区',367),
    (369,'昆都仑区',367),
    (370,'青山区',367),
    (371,'石拐区',367),
    (372,'白云矿区',367),
    (373,'九原区',367),
    (374,'土默特右旗',367),
    (375,'固阳县',367),
    (376,'达尔罕茂明安联合旗',367),
    (377,'乌海市',356),
    (378,'海勃湾区',377),
    (379,'海南区',377),
    (380,'乌达区',377),
    (381,'赤峰市',356),
    (382,'红山区',381),
    (383,'元宝山区',381),
    (384,'松山区',381),
    (385,'阿鲁科尔沁旗',381),
    (386,'巴林左旗',381),
    (387,'巴林右旗',381),
    (388,'林西县',381),
    (389,'克什克腾旗',381),
    (390,'翁牛特旗',381),
    (391,'喀喇沁旗',381),
    (392,'宁城县',381),
    (393,'敖汉旗',381),
    (394,'通辽市',356),
    (395,'科尔沁区',394),
    (396,'科尔沁左翼中旗',394),
    (397,'科尔沁左翼后旗',394),
    (398,'开鲁县',394),
    (399,'库伦旗',394),
    (400,'奈曼旗',394),
    (401,'扎鲁特旗',394),
    (402,'霍林郭勒市',394),
    (403,'鄂尔多斯市',356),
    (404,'市辖区',403),
    (405,'  东胜区',403),
    (406,'达拉特旗',403),
    (407,'准格尔旗',403),
    (408,'鄂托克前旗',403),
    (409,'鄂托克旗',403),
    (410,'杭锦旗',403),
    (411,'乌审旗',403),
    (412,'伊金霍洛旗',403),
    (413,'呼伦贝尔市',356),
    (414,'海拉尔区',413),
    (415,'阿荣旗',413),
    (416,'莫力达瓦达斡尔族自治旗',413),
    (417,'鄂伦春自治旗',413),
    (418,'鄂温克族自治旗',413),
    (419,'陈巴尔虎旗',413),
    (420,'新巴尔虎左旗',413),
    (421,'新巴尔虎右旗',413),
    (422,'满洲里市',413),
    (423,'牙克石市',413),
    (424,'扎兰屯市',413),
    (425,'额尔古纳市',413),
    (426,'根河市',413),
    (427,'巴彦淖尔市',356),
    (428,'临河区',427),
    (429,'五原县',427),
    (430,'磴口县',427),
    (431,'乌拉特前旗',427),
    (432,'乌拉特中旗',427),
    (433,'乌拉特后旗',427),
    (434,'杭锦后旗',427),
    (435,'乌兰察布市',356),
    (436,'集宁区',435),
    (437,'卓资县',435),
    (438,'化德县',435),
    (439,'商都县',435),
    (440,'兴和县',435),
    (441,'凉城县',435),
    (442,'察哈尔右翼前旗',435),
    (443,'察哈尔右翼中旗',435),
    (444,'察哈尔右翼后旗',435),
    (445,'四子王旗',435),
    (446,'丰镇市',435),
    (447,'兴安盟',356),
    (448,'乌兰浩特市',447),
    (449,'阿尔山市',447),
    (450,'科尔沁右翼前旗',447),
    (451,'科尔沁右翼中旗',447),
    (452,'扎赉特旗',447),
    (453,'突泉县',447),
    (454,'锡林郭勒盟',356),
    (455,'二连浩特市',454),
    (456,'锡林浩特市',454),
    (457,'阿巴嘎旗',454),
    (458,'苏尼特左旗',454),
    (459,'苏尼特右旗',454),
    (460,'东乌珠穆沁旗',454),
    (461,'西乌珠穆沁旗',454),
    (462,'太仆寺旗',454),
    (463,'镶黄旗',454),
    (464,'正镶白旗',454),
    (465,'正蓝旗',454),
    (466,'多伦县',454),
    (467,'阿拉善盟',356),
    (468,'阿拉善左旗',467),
    (469,'阿拉善右旗',467),
    (470,'额济纳旗',467),
    (471,'辽宁',0),
    (472,'沈阳市',471),
    (473,'和平区',472),
    (474,'沈河区',472),
    (475,'大东区',472),
    (476,'皇姑区',472),
    (477,'铁西区',472),
    (478,'苏家屯区',472),
    (479,'东陵区',472),
    (480,'沈北新区',472),
    (481,'于洪区',472),
    (482,'辽中县',472),
    (483,'康平县',472),
    (484,'法库县',472),
    (485,'新民市',472),
    (486,'大连市',471),
    (487,'中山区',486),
    (488,'西岗区',486),
    (489,'沙河口区',486),
    (490,'甘井子区',486),
    (491,'旅顺口区',486),
    (492,'金州区',486),
    (493,'长海县',486),
    (494,'瓦房店市',486),
    (495,'普兰店市',486),
    (496,'庄河市',486),
    (497,'鞍山市',471),
    (498,'铁东区',497),
    (499,'铁西区',497),
    (500,'立山区',497),
    (501,'千山区',497),
    (502,'台安县',497),
    (503,'岫岩满族自治县',497),
    (504,'海城市',497),
    (505,'抚顺市',471),
    (506,'新抚区',505),
    (507,'东洲区',505),
    (508,'望花区',505),
    (509,'顺城区',505),
    (510,'抚顺县',505),
    (511,'新宾满族自治县',505),
    (512,'清原满族自治县',505),
    (513,'本溪市',471),
    (514,'平山区',513),
    (515,'溪湖区',513),
    (516,'明山区',513),
    (517,'南芬区',513),
    (518,'本溪满族自治县',513),
    (519,'桓仁满族自治县',513),
    (520,'丹东市',471),
    (521,'元宝区',520),
    (522,'振兴区',520),
    (523,'振安区',520),
    (524,'宽甸满族自治县',520),
    (525,'东港市',520),
    (526,'凤城市',520),
    (527,'锦州市',471),
    (528,'古塔区',527),
    (529,'凌河区',527),
    (530,'太和区',527),
    (531,'黑山县',527),
    (532,'义县',527),
    (533,'凌海市',527),
    (534,'北镇市',527),
    (535,'营口市',471),
    (536,'站前区',535),
    (537,'西市区',535),
    (538,'鲅鱼圈区',535),
    (539,'老边区',535),
    (540,'盖州市',535),
    (541,'大石桥市',535),
    (542,'阜新市',471),
    (543,'海州区',542),
    (544,'新邱区',542),
    (545,'太平区',542),
    (546,'清河门区',542),
    (547,'细河区',542),
    (548,'阜新蒙古族自治县',542),
    (549,'彰武县',542),
    (550,'辽阳市',471),
    (551,'白塔区',550),
    (552,'文圣区',550),
    (553,'宏伟区',550),
    (554,'弓长岭区',550),
    (555,'太子河区',550),
    (556,'辽阳县',550),
    (557,'灯塔市',550),
    (558,'盘锦市',471),
    (559,'双台子区',558),
    (560,'兴隆台区',558),
    (561,'大洼县',558),
    (562,'盘山县',558),
    (563,'铁岭市',471),
    (564,'银州区',563),
    (565,'清河区',563),
    (566,'铁岭县',563),
    (567,'西丰县',563),
    (568,'昌图县',563),
    (569,'调兵山市',563),
    (570,'开原市',563),
    (571,'朝阳市',471),
    (572,'双塔区',571),
    (573,'龙城区',571),
    (574,'朝阳县',571),
    (575,'建平县',571),
    (576,'喀喇沁左翼蒙古族自治县',571),
    (577,'北票市',571),
    (578,'凌源市',571),
    (579,'葫芦岛市',471),
    (580,'连山区',579),
    (581,'龙港区',579),
    (582,'南票区',579),
    (583,'绥中县',579),
    (584,'建昌县',579),
    (585,'兴城市',579),
    (586,'吉林',0),
    (587,'长春市',586),
    (588,'南关区',587),
    (589,'宽城区',587),
    (590,'朝阳区',587),
    (591,'二道区',587),
    (592,'绿园区',587),
    (593,'双阳区',587),
    (594,'农安县',587),
    (595,'九台市',587),
    (596,'榆树市',587),
    (597,'德惠市',587),
    (598,'吉林市',586),
    (599,'昌邑区',598),
    (600,'龙潭区',598),
    (601,'船营区',598),
    (602,'丰满区',598),
    (603,'永吉县',598),
    (604,'蛟河市',598),
    (605,'桦甸市',598),
    (606,'舒兰市',598),
    (607,'磐石市',598),
    (608,'四平市',586),
    (609,'铁西区',608),
    (610,'铁东区',608),
    (611,'梨树县',608),
    (612,'伊通满族自治县',608),
    (613,'公主岭市',608),
    (614,'双辽市',608),
    (615,'辽源市',586),
    (616,'龙山区',615),
    (617,'西安区',615),
    (618,'东丰县',615),
    (619,'东辽县',615),
    (620,'通化市',586),
    (621,'东昌区',620),
    (622,'二道江区',620),
    (623,'通化县',620),
    (624,'辉南县',620),
    (625,'柳河县',620),
    (626,'梅河口市',620),
    (627,'集安市',620),
    (628,'白山市',586),
    (629,'八道江区',628),
    (630,'  江源区',628),
    (631,'抚松县',628),
    (632,'靖宇县',628),
    (633,'长白朝鲜族自治县',628),
    (634,'临江市',628),
    (635,'松原市',586),
    (636,'宁江区',635),
    (637,'前郭尔罗斯蒙古族自治县',635),
    (638,'长岭县',635),
    (639,'乾安县',635),
    (640,'扶余县',635),
    (641,'白城市',586),
    (642,'洮北区',641),
    (643,'镇赉县',641),
    (644,'通榆县',641),
    (645,'洮南市',641),
    (646,'大安市',641),
    (647,'延边朝鲜族自治州',586),
    (648,'延吉市',647),
    (649,'图们市',647),
    (650,'敦化市',647),
    (651,'珲春市',647),
    (652,'龙井市',647),
    (653,'和龙市',647),
    (654,'汪清县',647),
    (655,'安图县',647),
    (656,'黑龙江',0),
    (657,'哈尔滨市',656),
    (658,'道里区',657),
    (659,'南岗区',657),
    (660,'道外区',657),
    (661,'平房区',657),
    (662,'松北区',657),
    (663,'香坊区',657),
    (664,'呼兰区',657),
    (665,'阿城区                 ',657),
    (666,'依兰县',657),
    (667,'方正县',657),
    (668,'宾县',657),
    (669,'巴彦县',657),
    (670,'木兰县',657),
    (671,'通河县',657),
    (672,'延寿县',657),
    (673,'双城市',657),
    (674,'尚志市',657),
    (675,'五常市',657),
    (676,'齐齐哈尔市',656),
    (677,'龙沙区',676),
    (678,'建华区',676),
    (679,'铁锋区',676),
    (680,'昂昂溪区',676),
    (681,'富拉尔基区',676),
    (682,'碾子山区',676),
    (683,'梅里斯达斡尔族区',676),
    (684,'龙江县',676),
    (685,'依安县',676),
    (686,'泰来县',676),
    (687,'甘南县',676),
    (688,'富裕县',676),
    (689,'克山县',676),
    (690,'克东县',676),
    (691,'拜泉县',676),
    (692,'讷河市',676),
    (693,'鸡西市',656),
    (694,'鸡冠区',693),
    (695,'恒山区',693),
    (696,'滴道区',693),
    (697,'梨树区',693),
    (698,'城子河区',693),
    (699,'麻山区',693),
    (700,'鸡东县',693),
    (701,'虎林市',693),
    (702,'密山市',693),
    (703,'鹤岗市',656),
    (704,'向阳区',703),
    (705,'工农区',703),
    (706,'南山区',703),
    (707,'兴安区',703),
    (708,'东山区',703),
    (709,'兴山区',703),
    (710,'萝北县',703),
    (711,'绥滨县',703),
    (712,'双鸭山市',656),
    (713,'尖山区',712),
    (714,'岭东区',712),
    (715,'四方台区',712),
    (716,'宝山区',712),
    (717,'集贤县',712),
    (718,'友谊县',712),
    (719,'宝清县',712),
    (720,'饶河县',712),
    (721,'大庆市',656),
    (722,'萨尔图区',721),
    (723,'龙凤区',721),
    (724,'让胡路区',721),
    (725,'红岗区',721),
    (726,'大同区',721),
    (727,'肇州县',721),
    (728,'肇源县',721),
    (729,'林甸县',721),
    (730,'杜尔伯特蒙古族自治县',721),
    (731,'伊春市',656),
    (732,'伊春区',731),
    (733,'南岔区',731),
    (734,'友好区',731),
    (735,'西林区',731),
    (736,'翠峦区',731),
    (737,'新青区',731),
    (738,'美溪区',731),
    (739,'金山屯区',731),
    (740,'五营区',731),
    (741,'乌马河区',731),
    (742,'汤旺河区',731),
    (743,'带岭区',731),
    (744,'乌伊岭区',731),
    (745,'红星区',731),
    (746,'上甘岭区',731),
    (747,'嘉荫县',731),
    (748,'铁力市',731),
    (749,'佳木斯市',656),
    (750,'向阳区',749),
    (751,'前进区',749),
    (752,'东风区',749),
    (753,'郊区',749),
    (754,'桦南县',749),
    (755,'桦川县',749),
    (756,'汤原县',749),
    (757,'抚远县',749),
    (758,'同江市',749),
    (759,'富锦市',749),
    (760,'七台河市',656),
    (761,'新兴区',760),
    (762,'桃山区',760),
    (763,'茄子河区',760),
    (764,'勃利县',760),
    (765,'牡丹江市',656),
    (766,'东安区',765),
    (767,'阳明区',765),
    (768,'爱民区',765),
    (769,'西安区',765),
    (770,'东宁县',765),
    (771,'林口县',765),
    (772,'绥芬河市',765),
    (773,'海林市',765),
    (774,'宁安市',765),
    (775,'穆棱市',765),
    (776,'黑河市',656),
    (777,'爱辉区',776),
    (778,'嫩江县',776),
    (779,'逊克县',776),
    (780,'孙吴县',776),
    (781,'北安市',776),
    (782,'五大连池市',776),
    (783,'绥化市',656),
    (784,'北林区',783),
    (785,'望奎县',783),
    (786,'兰西县',783),
    (787,'青冈县',783),
    (788,'庆安县',783),
    (789,'明水县',783),
    (790,'绥棱县',783),
    (791,'安达市',783),
    (792,'肇东市',783),
    (793,'海伦市',783),
    (794,'大兴安岭地区',656),
    (795,'加格达奇区',794),
    (796,'松岭区',794),
    (797,'新林区',794),
    (798,'呼中区',794),
    (799,'呼玛县',794),
    (800,'塔河县',794),
    (801,'漠河县',794),
    (802,'上海',0),
    (803,'上海市',802),
    (804,'黄浦区',803),
    (805,'卢湾区',803),
    (806,'徐汇区',803),
    (807,'长宁区',803),
    (808,'静安区',803),
    (809,'普陀区',803),
    (810,'闸北区',803),
    (811,'虹口区',803),
    (812,'杨浦区',803),
    (813,'闵行区',803),
    (814,'宝山区',803),
    (815,'嘉定区',803),
    (816,'浦东新区',803),
    (817,'金山区',803),
    (818,'松江区',803),
    (819,'青浦区',803),
    (820,'南汇区',803),
    (821,'奉贤区',803),
    (822,'崇明县',803),
    (823,'江苏',0),
    (824,'南京市',823),
    (825,'玄武区',824),
    (826,'白下区',824),
    (827,'秦淮区',824),
    (828,'建邺区',824),
    (829,'鼓楼区',824),
    (830,'下关区',824),
    (831,'浦口区',824),
    (832,'栖霞区',824),
    (833,'雨花台区',824),
    (834,'江宁区',824),
    (835,'六合区',824),
    (836,'溧水县',824),
    (837,'高淳县',824),
    (838,'无锡市',823),
    (839,'崇安区',838),
    (840,'南长区',838),
    (841,'北塘区',838),
    (842,'锡山区',838),
    (843,'惠山区',838),
    (844,'滨湖区',838),
    (845,'江阴市',838),
    (846,'宜兴市',838),
    (847,'徐州市',823),
    (848,'鼓楼区',847),
    (849,'云龙区',847),
    (850,'九里区',847),
    (851,'贾汪区',847),
    (852,'泉山区',847),
    (853,'丰县',847),
    (854,'沛县',847),
    (855,'铜山县',847),
    (856,'睢宁县',847),
    (857,'新沂市',847),
    (858,'邳州市',847),
    (859,'常州市',823),
    (860,'天宁区',859),
    (861,'钟楼区',859),
    (862,'戚墅堰区',859),
    (863,'新北区',859),
    (864,'武进区',859),
    (865,'溧阳市',859),
    (866,'金坛市',859),
    (867,'苏州市',823),
    (868,'沧浪区',867),
    (869,'平江区',867),
    (870,'金阊区',867),
    (871,'虎丘区',867),
    (872,'吴中区',867),
    (873,'相城区',867),
    (874,'常熟市',867),
    (875,'张家港市',867),
    (876,'昆山市',867),
    (877,'吴江市',867),
    (878,'太仓市',867),
    (879,'南通市',823),
    (880,'崇川区',879),
    (881,'港闸区',879),
    (882,'海安县',879),
    (883,'如东县',879),
    (884,'启东市',879),
    (885,'如皋市',879),
    (886,'通州市',879),
    (887,'海门市',879),
    (888,'连云港市',823),
    (889,'连云区',888),
    (890,'新浦区',888),
    (891,'海州区',888),
    (892,'赣榆县',888),
    (893,'东海县',888),
    (894,'灌云县',888),
    (895,'灌南县',888),
    (896,'淮安市',823),
    (897,'清河区',896),
    (898,'楚州区',896),
    (899,'淮阴区',896),
    (900,'清浦区',896),
    (901,'涟水县',896),
    (902,'洪泽县',896),
    (903,'盱眙县',896),
    (904,'金湖县',896),
    (905,'盐城市',823),
    (906,'亭湖区',905),
    (907,'盐都区',905),
    (908,'响水县',905),
    (909,'滨海县',905),
    (910,'阜宁县',905),
    (911,'射阳县',905),
    (912,'建湖县',905),
    (913,'东台市',905),
    (914,'大丰市',905),
    (915,'扬州市',823),
    (916,'广陵区',915),
    (917,'邗江区',915),
    (918,'维扬区',915),
    (919,'宝应县',915),
    (920,'仪征市',915),
    (921,'高邮市',915),
    (922,'江都市',915),
    (923,'镇江市',823),
    (924,'京口区',923),
    (925,'润州区',923),
    (926,'丹徒区',923),
    (927,'丹阳市',923),
    (928,'扬中市',923),
    (929,'句容市',923),
    (930,'泰州市',823),
    (931,'海陵区',930),
    (932,'高港区',930),
    (933,'兴化市',930),
    (934,'靖江市',930),
    (935,'泰兴市',930),
    (936,'姜堰市',930),
    (937,'宿迁市',823),
    (938,'宿城区',937),
    (939,'宿豫区',937),
    (940,'沭阳县',937),
    (941,'泗阳县',937),
    (942,'泗洪县',937),
    (943,'浙江',0),
    (944,'杭州市',943),
    (945,'上城区',944),
    (946,'下城区',944),
    (947,'江干区',944),
    (948,'拱墅区',944),
    (949,'西湖区',944),
    (950,'滨江区',944),
    (951,'萧山区',944),
    (952,'余杭区',944),
    (953,'桐庐县',944),
    (954,'淳安县',944),
    (955,'建德市',944),
    (956,'富阳市',944),
    (957,'临安市',944),
    (958,'宁波市',943),
    (959,'海曙区',958),
    (960,'江东区',958),
    (961,'江北区',958),
    (962,'北仑区',958),
    (963,'镇海区',958),
    (964,'鄞州区',958),
    (965,'象山县',958),
    (966,'宁海县',958),
    (967,'余姚市',958),
    (968,'慈溪市',958),
    (969,'奉化市',958),
    (970,'温州市',943),
    (971,'鹿城区',970),
    (972,'龙湾区',970),
    (973,'瓯海区',970),
    (974,'洞头县',970),
    (975,'永嘉县',970),
    (976,'平阳县',970),
    (977,'苍南县',970),
    (978,'文成县',970),
    (979,'泰顺县',970),
    (980,'瑞安市',970),
    (981,'乐清市',970),
    (982,'嘉兴市',943),
    (983,'南湖区',982),
    (984,'秀洲区',982),
    (985,'嘉善县',982),
    (986,'海盐县',982),
    (987,'海宁市',982),
    (988,'平湖市',982),
    (989,'桐乡市',982),
    (990,'湖州市',943),
    (991,'吴兴区',990),
    (992,'南浔区',990),
    (993,'德清县',990),
    (994,'长兴县',990),
    (995,'安吉县',990),
    (996,'绍兴市',943),
    (997,'越城区',996),
    (998,'绍兴县',996),
    (999,'新昌县',996),
    (1000,'诸暨市',996),
    (1001,'上虞市',996),
    (1002,'嵊州市',996),
    (1003,'金华市',943),
    (1004,'婺城区',1003),
    (1005,'金东区',1003),
    (1006,'武义县',1003),
    (1007,'浦江县',1003),
    (1008,'磐安县',1003),
    (1009,'兰溪市',1003),
    (1010,'义乌市',1003),
    (1011,'东阳市',1003),
    (1012,'永康市',1003),
    (1013,'衢州市',943),
    (1014,'柯城区',1013),
    (1015,'衢江区',1013),
    (1016,'常山县',1013),
    (1017,'开化县',1013),
    (1018,'龙游县',1013),
    (1019,'江山市',1013),
    (1020,'舟山市',943),
    (1021,'定海区',1020),
    (1022,'普陀区',1020),
    (1023,'岱山县',1020),
    (1024,'嵊泗县',1020),
    (1025,'台州市',943),
    (1026,'椒江区',1025),
    (1027,'黄岩区',1025),
    (1028,'路桥区',1025),
    (1029,'玉环县',1025),
    (1030,'三门县',1025),
    (1031,'天台县',1025),
    (1032,'仙居县',1025),
    (1033,'温岭市',1025),
    (1034,'临海市',1025),
    (1035,'丽水市',943),
    (1036,'莲都区',1035),
    (1037,'青田县',1035),
    (1038,'缙云县',1035),
    (1039,'遂昌县',1035),
    (1040,'松阳县',1035),
    (1041,'云和县',1035),
    (1042,'庆元县',1035),
    (1043,'景宁畲族自治县',1035),
    (1044,'龙泉市',1035),
    (1045,'安徽',0),
    (1046,'合肥市',1045),
    (1047,'瑶海区',1046),
    (1048,'庐阳区',1046),
    (1049,'蜀山区',1046),
    (1050,'包河区',1046),
    (1051,'长丰县',1046),
    (1052,'肥东县',1046),
    (1053,'肥西县',1046),
    (1054,'芜湖市',1045),
    (1055,'镜湖区',1054),
    (1056,'弋江区',1054),
    (1057,'鸠江区',1054),
    (1058,'三山区',1054),
    (1059,'芜湖县',1054),
    (1060,'繁昌县',1054),
    (1061,'南陵县',1054),
    (1062,'蚌埠市',1045),
    (1063,'龙子湖区',1062),
    (1064,'蚌山区',1062),
    (1065,'禹会区',1062),
    (1066,'淮上区',1062),
    (1067,'怀远县',1062),
    (1068,'五河县',1062),
    (1069,'固镇县',1062),
    (1070,'淮南市',1045),
    (1071,'大通区',1070),
    (1072,'田家庵区',1070),
    (1073,'谢家集区',1070),
    (1074,'八公山区',1070),
    (1075,'潘集区',1070),
    (1076,'凤台县',1070),
    (1077,'马鞍山市',1045),
    (1078,'金家庄区',1077),
    (1079,'花山区',1077),
    (1080,'雨山区',1077),
    (1081,'当涂县',1077),
    (1082,'淮北市',1045),
    (1083,'杜集区',1082),
    (1084,'相山区',1082),
    (1085,'烈山区',1082),
    (1086,'濉溪县',1082),
    (1087,'铜陵市',1045),
    (1088,'铜官山区',1087),
    (1089,'狮子山区',1087),
    (1090,'郊区',1087),
    (1091,'铜陵县',1087),
    (1092,'安庆市',1045),
    (1093,'迎江区',1092),
    (1094,'大观区',1092),
    (1095,'宜秀区',1092),
    (1096,'怀宁县',1092),
    (1097,'枞阳县',1092),
    (1098,'潜山县',1092),
    (1099,'太湖县',1092),
    (1100,'宿松县',1092),
    (1101,'望江县',1092),
    (1102,'岳西县',1092),
    (1103,'桐城市',1092),
    (1104,'黄山市',1045),
    (1105,'屯溪区',1104),
    (1106,'黄山区',1104),
    (1107,'徽州区',1104),
    (1108,'歙县',1104),
    (1109,'休宁县',1104),
    (1110,'黟县',1104),
    (1111,'祁门县',1104),
    (1112,'滁州市',1045),
    (1113,'琅琊区',1112),
    (1114,'南谯区',1112),
    (1115,'来安县',1112),
    (1116,'全椒县',1112),
    (1117,'定远县',1112),
    (1118,'凤阳县',1112),
    (1119,'天长市',1112),
    (1120,'明光市',1112),
    (1121,'阜阳市',1045),
    (1122,'颍州区',1121),
    (1123,'颍东区',1121),
    (1124,'颍泉区',1121),
    (1125,'临泉县',1121),
    (1126,'太和县',1121),
    (1127,'阜南县',1121),
    (1128,'颍上县',1121),
    (1129,'界首市',1121),
    (1130,'宿州市',1045),
    (1131,'埇桥区',1130),
    (1132,'砀山县',1130),
    (1133,'萧县',1130),
    (1134,'灵璧县',1130),
    (1135,'泗县',1130),
    (1136,'巢湖市',1045),
    (1137,'居巢区',1136),
    (1138,'庐江县',1136),
    (1139,'无为县',1136),
    (1140,'含山县',1136),
    (1141,'和县',1136),
    (1142,'六安市',1045),
    (1143,'金安区',1142),
    (1144,'裕安区',1142),
    (1145,'寿县',1142),
    (1146,'霍邱县',1142),
    (1147,'舒城县',1142),
    (1148,'金寨县',1142),
    (1149,'霍山县',1142),
    (1150,'亳州市',1045),
    (1151,'谯城区',1150),
    (1152,'涡阳县',1150),
    (1153,'蒙城县',1150),
    (1154,'利辛县',1150),
    (1155,'池州市',1045),
    (1156,'贵池区',1155),
    (1157,'东至县',1155),
    (1158,'石台县',1155),
    (1159,'青阳县',1155),
    (1160,'宣城市',1045),
    (1161,'宣州区',1160),
    (1162,'郎溪县',1160),
    (1163,'广德县',1160),
    (1164,'泾县',1160),
    (1165,'绩溪县',1160),
    (1166,'旌德县',1160),
    (1167,'宁国市',1160),
    (1168,'福建',0),
    (1169,'福州市',1168),
    (1170,'鼓楼区',1169),
    (1171,'台江区',1169),
    (1172,'仓山区',1169),
    (1173,'马尾区',1169),
    (1174,'晋安区',1169),
    (1175,'闽侯县',1169),
    (1176,'连江县',1169),
    (1177,'罗源县',1169),
    (1178,'闽清县',1169),
    (1179,'永泰县',1169),
    (1180,'平潭县',1169),
    (1181,'福清市',1169),
    (1182,'长乐市',1169),
    (1183,'厦门市',1168),
    (1184,'思明区',1183),
    (1185,'海沧区',1183),
    (1186,'湖里区',1183),
    (1187,'集美区',1183),
    (1188,'同安区',1183),
    (1189,'翔安区',1183),
    (1190,'莆田市',1168),
    (1191,'城厢区',1190),
    (1192,'涵江区',1190),
    (1193,'荔城区',1190),
    (1194,'秀屿区',1190),
    (1195,'仙游县',1190),
    (1196,'三明市',1168),
    (1197,'梅列区',1196),
    (1198,'三元区',1196),
    (1199,'明溪县',1196),
    (1200,'清流县',1196),
    (1201,'宁化县',1196),
    (1202,'大田县',1196),
    (1203,'尤溪县',1196),
    (1204,'沙县',1196),
    (1205,'将乐县',1196),
    (1206,'泰宁县',1196),
    (1207,'建宁县',1196),
    (1208,'永安市',1196),
    (1209,'泉州市',1168),
    (1210,'鲤城区',1209),
    (1211,'丰泽区',1209),
    (1212,'洛江区',1209),
    (1213,'泉港区',1209),
    (1214,'惠安县',1209),
    (1215,'安溪县',1209),
    (1216,'永春县',1209),
    (1217,'德化县',1209),
    (1218,'金门县',1209),
    (1219,'石狮市',1209),
    (1220,'晋江市',1209),
    (1221,'南安市',1209),
    (1222,'漳州市',1168),
    (1223,'芗城区',1222),
    (1224,'龙文区',1222),
    (1225,'云霄县',1222),
    (1226,'漳浦县',1222),
    (1227,'诏安县',1222),
    (1228,'长泰县',1222),
    (1229,'东山县',1222),
    (1230,'南靖县',1222),
    (1231,'平和县',1222),
    (1232,'华安县',1222),
    (1233,'龙海市',1222),
    (1234,'南平市',1168),
    (1235,'延平区',1234),
    (1236,'顺昌县',1234),
    (1237,'浦城县',1234),
    (1238,'光泽县',1234),
    (1239,'松溪县',1234),
    (1240,'政和县',1234),
    (1241,'邵武市',1234),
    (1242,'武夷山市',1234),
    (1243,'建瓯市',1234),
    (1244,'建阳市',1234),
    (1245,'龙岩市',1168),
    (1246,'新罗区',1245),
    (1247,'长汀县',1245),
    (1248,'永定县',1245),
    (1249,'上杭县',1245),
    (1250,'武平县',1245),
    (1251,'连城县',1245),
    (1252,'漳平市',1245),
    (1253,'宁德市',1168),
    (1254,'蕉城区',1253),
    (1255,'霞浦县',1253),
    (1256,'古田县',1253),
    (1257,'屏南县',1253),
    (1258,'寿宁县',1253),
    (1259,'周宁县',1253),
    (1260,'柘荣县',1253),
    (1261,'福安市',1253),
    (1262,'福鼎市',1253),
    (1263,'江西',0),
    (1264,'南昌市',1263),
    (1265,'东湖区',1264),
    (1266,'西湖区',1264),
    (1267,'青云谱区',1264),
    (1268,'湾里区',1264),
    (1269,'青山湖区',1264),
    (1270,'南昌县',1264),
    (1271,'新建县',1264),
    (1272,'安义县',1264),
    (1273,'进贤县',1264),
    (1274,'景德镇市',1263),
    (1275,'昌江区',1274),
    (1276,'珠山区',1274),
    (1277,'浮梁县',1274),
    (1278,'乐平市',1274),
    (1279,'萍乡市',1263),
    (1280,'安源区',1279),
    (1281,'湘东区',1279),
    (1282,'莲花县',1279),
    (1283,'上栗县',1279),
    (1284,'芦溪县',1279),
    (1285,'九江市',1263),
    (1286,'庐山区',1285),
    (1287,'浔阳区',1285),
    (1288,'九江县',1285),
    (1289,'武宁县',1285),
    (1290,'修水县',1285),
    (1291,'永修县',1285),
    (1292,'德安县',1285),
    (1293,'星子县',1285),
    (1294,'都昌县',1285),
    (1295,'湖口县',1285),
    (1296,'彭泽县',1285),
    (1297,'瑞昌市',1285),
    (1298,'新余市',1263),
    (1299,'渝水区',1298),
    (1300,'分宜县',1298),
    (1301,'鹰潭市',1263),
    (1302,'月湖区',1301),
    (1303,'余江县',1301),
    (1304,'贵溪市',1301),
    (1305,'赣州市',1263),
    (1306,'章贡区',1305),
    (1307,'赣县',1305),
    (1308,'信丰县',1305),
    (1309,'大余县',1305),
    (1310,'上犹县',1305),
    (1311,'崇义县',1305),
    (1312,'安远县',1305),
    (1313,'龙南县',1305),
    (1314,'定南县',1305),
    (1315,'全南县',1305),
    (1316,'宁都县',1305),
    (1317,'于都县',1305),
    (1318,'兴国县',1305),
    (1319,'会昌县',1305),
    (1320,'寻乌县',1305),
    (1321,'石城县',1305),
    (1322,'瑞金市',1305),
    (1323,'南康市',1305),
    (1324,'吉安市',1263),
    (1325,'吉州区',1324),
    (1326,'青原区',1324),
    (1327,'吉安县',1324),
    (1328,'吉水县',1324),
    (1329,'峡江县',1324),
    (1330,'新干县',1324),
    (1331,'永丰县',1324),
    (1332,'泰和县',1324),
    (1333,'遂川县',1324),
    (1334,'万安县',1324),
    (1335,'安福县',1324),
    (1336,'永新县',1324),
    (1337,'井冈山市',1324),
    (1338,'宜春市',1263),
    (1339,'袁州区',1338),
    (1340,'奉新县',1338),
    (1341,'万载县',1338),
    (1342,'上高县',1338),
    (1343,'宜丰县',1338),
    (1344,'靖安县',1338),
    (1345,'铜鼓县',1338),
    (1346,'丰城市',1338),
    (1347,'樟树市',1338),
    (1348,'高安市',1338),
    (1349,'抚州市',1263),
    (1350,'临川区',1349),
    (1351,'南城县',1349),
    (1352,'黎川县',1349),
    (1353,'南丰县',1349),
    (1354,'崇仁县',1349),
    (1355,'乐安县',1349),
    (1356,'宜黄县',1349),
    (1357,'金溪县',1349),
    (1358,'资溪县',1349),
    (1359,'东乡县',1349),
    (1360,'广昌县',1349),
    (1361,'上饶市',1263),
    (1362,'信州区',1361),
    (1363,'上饶县',1361),
    (1364,'广丰县',1361),
    (1365,'玉山县',1361),
    (1366,'铅山县',1361),
    (1367,'横峰县',1361),
    (1368,'弋阳县',1361),
    (1369,'余干县',1361),
    (1370,'鄱阳县',1361),
    (1371,'万年县',1361),
    (1372,'婺源县',1361),
    (1373,'德兴市',1361),
    (1374,'山东',0),
    (1375,'济南市',1374),
    (1376,'历下区',1375),
    (1377,'市中区',1375),
    (1378,'槐荫区',1375),
    (1379,'天桥区',1375),
    (1380,'历城区',1375),
    (1381,'长清区',1375),
    (1382,'平阴县',1375),
    (1383,'济阳县',1375),
    (1384,'商河县',1375),
    (1385,'章丘市',1375),
    (1386,'青岛市',1374),
    (1387,'市南区',1386),
    (1388,'市北区',1386),
    (1389,'四方区',1386),
    (1390,'黄岛区',1386),
    (1391,'崂山区',1386),
    (1392,'李沧区',1386),
    (1393,'城阳区',1386),
    (1394,'胶州市',1386),
    (1395,'即墨市',1386),
    (1396,'平度市',1386),
    (1397,'胶南市',1386),
    (1398,'莱西市',1386),
    (1399,'淄博市',1374),
    (1400,'淄川区',1399),
    (1401,'张店区',1399),
    (1402,'博山区',1399),
    (1403,'临淄区',1399),
    (1404,'周村区',1399),
    (1405,'桓台县',1399),
    (1406,'高青县',1399),
    (1407,'沂源县',1399),
    (1408,'枣庄市',1374),
    (1409,'市中区',1408),
    (1410,'薛城区',1408),
    (1411,'峄城区',1408),
    (1412,'台儿庄区',1408),
    (1413,'山亭区',1408),
    (1414,'滕州市',1408),
    (1415,'东营市',1374),
    (1416,'东营区',1415),
    (1417,'河口区',1415),
    (1418,'垦利县',1415),
    (1419,'利津县',1415),
    (1420,'广饶县',1415),
    (1421,'烟台市',1374),
    (1422,'芝罘区',1421),
    (1423,'福山区',1421),
    (1424,'牟平区',1421),
    (1425,'莱山区',1421),
    (1426,'长岛县',1421),
    (1427,'龙口市',1421),
    (1428,'莱阳市',1421),
    (1429,'莱州市',1421),
    (1430,'蓬莱市',1421),
    (1431,'招远市',1421),
    (1432,'栖霞市',1421),
    (1433,'海阳市',1421),
    (1434,'潍坊市',1374),
    (1435,'潍城区',1434),
    (1436,'寒亭区',1434),
    (1437,'坊子区',1434),
    (1438,'奎文区',1434),
    (1439,'临朐县',1434),
    (1440,'昌乐县',1434),
    (1441,'青州市',1434),
    (1442,'诸城市',1434),
    (1443,'寿光市',1434),
    (1444,'安丘市',1434),
    (1445,'高密市',1434),
    (1446,'昌邑市',1434),
    (1447,'济宁市',1374),
    (1448,'市中区',1447),
    (1449,'任城区',1447),
    (1450,'微山县',1447),
    (1451,'鱼台县',1447),
    (1452,'金乡县',1447),
    (1453,'嘉祥县',1447),
    (1454,'汶上县',1447),
    (1455,'泗水县',1447),
    (1456,'梁山县',1447),
    (1457,'曲阜市',1447),
    (1458,'兖州市',1447),
    (1459,'邹城市',1447),
    (1460,'泰安市',1374),
    (1461,'泰山区',1460),
    (1462,'岱岳区',1460),
    (1463,'宁阳县',1460),
    (1464,'东平县',1460),
    (1465,'新泰市',1460),
    (1466,'肥城市',1460),
    (1467,'威海市',1374),
    (1468,'环翠区',1467),
    (1469,'文登市',1467),
    (1470,'荣成市',1467),
    (1471,'乳山市',1467),
    (1472,'日照市',1374),
    (1473,'东港区',1472),
    (1474,'岚山区',1472),
    (1475,'五莲县',1472),
    (1476,'莒县',1472),
    (1477,'莱芜市',1374),
    (1478,'莱城区',1477),
    (1479,'钢城区',1477),
    (1480,'临沂市',1374),
    (1481,'兰山区',1480),
    (1482,'罗庄区',1480),
    (1483,'河东区',1480),
    (1484,'沂南县',1480),
    (1485,'郯城县',1480),
    (1486,'沂水县',1480),
    (1487,'苍山县',1480),
    (1488,'费县',1480),
    (1489,'平邑县',1480),
    (1490,'莒南县',1480),
    (1491,'蒙阴县',1480),
    (1492,'临沭县',1480),
    (1493,'德州市',1374),
    (1494,'德城区',1493),
    (1495,'陵县',1493),
    (1496,'宁津县',1493),
    (1497,'庆云县',1493),
    (1498,'临邑县',1493),
    (1499,'齐河县',1493),
    (1500,'平原县',1493),
    (1501,'夏津县',1493),
    (1502,'武城县',1493),
    (1503,'乐陵市',1493),
    (1504,'禹城市',1493),
    (1505,'聊城市',1374),
    (1506,'东昌府区',1505),
    (1507,'阳谷县',1505),
    (1508,'莘县',1505),
    (1509,'茌平县',1505),
    (1510,'东阿县',1505),
    (1511,'冠县',1505),
    (1512,'高唐县',1505),
    (1513,'临清市',1505),
    (1514,'滨州市',1374),
    (1515,'滨城区',1514),
    (1516,'惠民县',1514),
    (1517,'阳信县',1514),
    (1518,'无棣县',1514),
    (1519,'沾化县',1514),
    (1520,'博兴县',1514),
    (1521,'邹平县',1514),
    (1522,'菏泽市',1374),
    (1523,'牡丹区',1522),
    (1524,'曹县',1522),
    (1525,'单县',1522),
    (1526,'成武县',1522),
    (1527,'巨野县',1522),
    (1528,'郓城县',1522),
    (1529,'鄄城县',1522),
    (1530,'定陶县',1522),
    (1531,'东明县',1522),
    (1532,'河南',0),
    (1533,'郑州市',1532),
    (1534,'中原区',1533),
    (1535,'二七区',1533),
    (1536,'管城回族区',1533),
    (1537,'金水区',1533),
    (1538,'上街区',1533),
    (1539,'惠济区',1533),
    (1540,'中牟县',1533),
    (1541,'巩义市',1533),
    (1542,'荥阳市',1533),
    (1543,'新密市',1533),
    (1544,'新郑市',1533),
    (1545,'登封市',1533),
    (1546,'开封市',1532),
    (1547,'龙亭区',1546),
    (1548,'顺河回族区',1546),
    (1549,'鼓楼区',1546),
    (1550,'禹王台区',1546),
    (1551,'金明区',1546),
    (1552,'杞县',1546),
    (1553,'通许县',1546),
    (1554,'尉氏县',1546),
    (1555,'开封县',1546),
    (1556,'兰考县',1546),
    (1557,'洛阳市',1532),
    (1558,'老城区',1557),
    (1559,'西工区',1557),
    (1560,'瀍河回族区',1557),
    (1561,'涧西区',1557),
    (1562,'吉利区',1557),
    (1563,'洛龙区',1557),
    (1564,'孟津县',1557),
    (1565,'新安县',1557),
    (1566,'栾川县',1557),
    (1567,'嵩县',1557),
    (1568,'汝阳县',1557),
    (1569,'宜阳县',1557),
    (1570,'洛宁县',1557),
    (1571,'伊川县',1557),
    (1572,'偃师市',1557),
    (1573,'平顶山市',1532),
    (1574,'新华区',1573),
    (1575,'卫东区',1573),
    (1576,'石龙区',1573),
    (1577,'湛河区',1573),
    (1578,'宝丰县',1573),
    (1579,'叶县',1573),
    (1580,'鲁山县',1573),
    (1581,'郏县',1573),
    (1582,'舞钢市',1573),
    (1583,'汝州市',1573),
    (1584,'安阳市',1532),
    (1585,'文峰区',1584),
    (1586,'北关区',1584),
    (1587,'殷都区',1584),
    (1588,'龙安区',1584),
    (1589,'安阳县',1584),
    (1590,'汤阴县',1584),
    (1591,'滑县',1584),
    (1592,'内黄县',1584),
    (1593,'林州市',1584),
    (1594,'鹤壁市',1532),
    (1595,'鹤山区',1594),
    (1596,'山城区',1594),
    (1597,'淇滨区',1594),
    (1598,'浚县',1594),
    (1599,'淇县',1594),
    (1600,'新乡市',1532),
    (1601,'红旗区',1600),
    (1602,'卫滨区',1600),
    (1603,'凤泉区',1600),
    (1604,'牧野区',1600),
    (1605,'新乡县',1600),
    (1606,'获嘉县',1600),
    (1607,'原阳县',1600),
    (1608,'延津县',1600),
    (1609,'封丘县',1600),
    (1610,'长垣县',1600),
    (1611,'卫辉市',1600),
    (1612,'辉县市',1600),
    (1613,'焦作市',1532),
    (1614,'解放区',1613),
    (1615,'中站区',1613),
    (1616,'马村区',1613),
    (1617,'山阳区',1613),
    (1618,'修武县',1613),
    (1619,'博爱县',1613),
    (1620,'武陟县',1613),
    (1621,'温县',1613),
    (1622,'济源市',1613),
    (1623,'沁阳市',1613),
    (1624,'孟州市',1613),
    (1625,'濮阳市',1532),
    (1626,'华龙区',1625),
    (1627,'清丰县',1625),
    (1628,'南乐县',1625),
    (1629,'范县',1625),
    (1630,'台前县',1625),
    (1631,'濮阳县',1625),
    (1632,'许昌市',1532),
    (1633,'魏都区',1632),
    (1634,'许昌县',1632),
    (1635,'鄢陵县',1632),
    (1636,'襄城县',1632),
    (1637,'禹州市',1632),
    (1638,'长葛市',1632),
    (1639,'漯河市',1532),
    (1640,'源汇区',1639),
    (1641,'郾城区',1639),
    (1642,'召陵区',1639),
    (1643,'舞阳县',1639),
    (1644,'临颍县',1639),
    (1645,'三门峡市',1532),
    (1646,'湖滨区',1645),
    (1647,'渑池县',1645),
    (1648,'陕县',1645),
    (1649,'卢氏县',1645),
    (1650,'义马市',1645),
    (1651,'灵宝市',1645),
    (1652,'南阳市',1532),
    (1653,'宛城区',1652),
    (1654,'卧龙区',1652),
    (1655,'南召县',1652),
    (1656,'方城县',1652),
    (1657,'西峡县',1652),
    (1658,'镇平县',1652),
    (1659,'内乡县',1652),
    (1660,'淅川县',1652),
    (1661,'社旗县',1652),
    (1662,'唐河县',1652),
    (1663,'新野县',1652),
    (1664,'桐柏县',1652),
    (1665,'邓州市',1652),
    (1666,'商丘市',1532),
    (1667,'梁园区',1666),
    (1668,'睢阳区',1666),
    (1669,'民权县',1666),
    (1670,'睢县',1666),
    (1671,'宁陵县',1666),
    (1672,'柘城县',1666),
    (1673,'虞城县',1666),
    (1674,'夏邑县',1666),
    (1675,'永城市',1666),
    (1676,'信阳市',1532),
    (1677,'浉河区',1676),
    (1678,'平桥区',1676),
    (1679,'罗山县',1676),
    (1680,'光山县',1676),
    (1681,'新县',1676),
    (1682,'商城县',1676),
    (1683,'固始县',1676),
    (1684,'潢川县',1676),
    (1685,'淮滨县',1676),
    (1686,'息县',1676),
    (1687,'周口市',1532),
    (1688,'川汇区',1687),
    (1689,'扶沟县',1687),
    (1690,'西华县',1687),
    (1691,'商水县',1687),
    (1692,'沈丘县',1687),
    (1693,'郸城县',1687),
    (1694,'淮阳县',1687),
    (1695,'太康县',1687),
    (1696,'鹿邑县',1687),
    (1697,'项城市',1687),
    (1698,'驻马店市',1532),
    (1699,'驿城区',1698),
    (1700,'西平县',1698),
    (1701,'上蔡县',1698),
    (1702,'平舆县',1698),
    (1703,'正阳县',1698),
    (1704,'确山县',1698),
    (1705,'泌阳县',1698),
    (1706,'汝南县',1698),
    (1707,'遂平县',1698),
    (1708,'新蔡县',1698),
    (1709,'湖北',0),
    (1710,'武汉市',1709),
    (1711,'江岸区',1710),
    (1712,'江汉区',1710),
    (1713,'硚口区',1710),
    (1714,'汉阳区',1710),
    (1715,'武昌区',1710),
    (1716,'青山区',1710),
    (1717,'洪山区',1710),
    (1718,'东西湖区',1710),
    (1719,'汉南区',1710),
    (1720,'蔡甸区',1710),
    (1721,'江夏区',1710),
    (1722,'黄陂区',1710),
    (1723,'新洲区',1710),
    (1724,'黄石市',1709),
    (1725,'黄石港区',1724),
    (1726,'西塞山区',1724),
    (1727,'下陆区',1724),
    (1728,'铁山区',1724),
    (1729,'阳新县',1724),
    (1730,'大冶市',1724),
    (1731,'十堰市',1709),
    (1732,'茅箭区',1731),
    (1733,'张湾区',1731),
    (1734,'郧县',1731),
    (1735,'郧西县',1731),
    (1736,'竹山县',1731),
    (1737,'竹溪县',1731),
    (1738,'房县',1731),
    (1739,'丹江口市',1731),
    (1740,'宜昌市',1709),
    (1741,'西陵区',1740),
    (1742,'伍家岗区',1740),
    (1743,'点军区',1740),
    (1744,'猇亭区',1740),
    (1745,'夷陵区',1740),
    (1746,'远安县',1740),
    (1747,'兴山县',1740),
    (1748,'秭归县',1740),
    (1749,'长阳土家族自治县',1740),
    (1750,'五峰土家族自治县',1740),
    (1751,'宜都市',1740),
    (1752,'当阳市',1740),
    (1753,'枝江市',1740),
    (1754,'襄樊市',1709),
    (1755,'襄城区',1754),
    (1756,'樊城区',1754),
    (1757,'襄阳区',1754),
    (1758,'南漳县',1754),
    (1759,'谷城县',1754),
    (1760,'保康县',1754),
    (1761,'老河口市',1754),
    (1762,'枣阳市',1754),
    (1763,'宜城市',1754),
    (1764,'鄂州市',1709),
    (1765,'梁子湖区',1764),
    (1766,'华容区',1764),
    (1767,'鄂城区',1764),
    (1768,'荆门市',1709),
    (1769,'东宝区',1768),
    (1770,'掇刀区',1768),
    (1771,'京山县',1768),
    (1772,'沙洋县',1768),
    (1773,'钟祥市',1768),
    (1774,'孝感市',1709),
    (1775,'孝南区',1774),
    (1776,'孝昌县',1774),
    (1777,'大悟县',1774),
    (1778,'云梦县',1774),
    (1779,'应城市',1774),
    (1780,'安陆市',1774),
    (1781,'汉川市',1774),
    (1782,'荆州市',1709),
    (1783,'沙市区',1782),
    (1784,'荆州区',1782),
    (1785,'公安县',1782),
    (1786,'监利县',1782),
    (1787,'江陵县',1782),
    (1788,'石首市',1782),
    (1789,'洪湖市',1782),
    (1790,'松滋市',1782),
    (1791,'黄冈市',1709),
    (1792,'黄州区',1791),
    (1793,'团风县',1791),
    (1794,'红安县',1791),
    (1795,'罗田县',1791),
    (1796,'英山县',1791),
    (1797,'浠水县',1791),
    (1798,'蕲春县',1791),
    (1799,'黄梅县',1791),
    (1800,'麻城市',1791),
    (1801,'武穴市',1791),
    (1802,'咸宁市',1709),
    (1803,'咸安区',1802),
    (1804,'嘉鱼县',1802),
    (1805,'通城县',1802),
    (1806,'崇阳县',1802),
    (1807,'通山县',1802),
    (1808,'赤壁市',1802),
    (1809,'随州市',1709),
    (1810,'曾都区',1809),
    (1811,'广水市',1809),
    (1812,'恩施土家族苗族自治州',1709),
    (1813,'恩施市',1812),
    (1814,'利川市',1812),
    (1815,'建始县',1812),
    (1816,'巴东县',1812),
    (1817,'宣恩县',1812),
    (1818,'咸丰县',1812),
    (1819,'来凤县',1812),
    (1820,'鹤峰县',1812),
    (1821,'省直辖县级行政单位',1709),
    (1822,'仙桃市',1821),
    (1823,'潜江市',1821),
    (1824,'天门市',1821),
    (1825,'神农架林区',1821),
    (1826,'湖南',0),
    (1827,'长沙市',1826),
    (1828,'芙蓉区',1827),
    (1829,'天心区',1827),
    (1830,'岳麓区',1827),
    (1831,'开福区',1827),
    (1832,'雨花区',1827),
    (1833,'长沙县',1827),
    (1834,'望城县',1827),
    (1835,'宁乡县',1827),
    (1836,'浏阳市',1827),
    (1837,'株洲市',1826),
    (1838,'荷塘区',1837),
    (1839,'芦淞区',1837),
    (1840,'石峰区',1837),
    (1841,'天元区',1837),
    (1842,'株洲县',1837),
    (1843,'攸县',1837),
    (1844,'茶陵县',1837),
    (1845,'炎陵县',1837),
    (1846,'醴陵市',1837),
    (1847,'湘潭市',1826),
    (1848,'雨湖区',1847),
    (1849,'岳塘区',1847),
    (1850,'湘潭县',1847),
    (1851,'湘乡市',1847),
    (1852,'韶山市',1847),
    (1853,'衡阳市',1826),
    (1854,'珠晖区',1853),
    (1855,'雁峰区',1853),
    (1856,'石鼓区',1853),
    (1857,'蒸湘区',1853),
    (1858,'南岳区',1853),
    (1859,'衡阳县',1853),
    (1860,'衡南县',1853),
    (1861,'衡山县',1853),
    (1862,'衡东县',1853),
    (1863,'祁东县',1853),
    (1864,'耒阳市',1853),
    (1865,'常宁市',1853),
    (1866,'邵阳市',1826),
    (1867,'双清区',1866),
    (1868,'大祥区',1866),
    (1869,'北塔区',1866),
    (1870,'邵东县',1866),
    (1871,'新邵县',1866),
    (1872,'邵阳县',1866),
    (1873,'隆回县',1866),
    (1874,'洞口县',1866),
    (1875,'绥宁县',1866),
    (1876,'新宁县',1866),
    (1877,'城步苗族自治县',1866),
    (1878,'武冈市',1866),
    (1879,'岳阳市',1826),
    (1880,'岳阳楼区',1879),
    (1881,'云溪区',1879),
    (1882,'君山区',1879),
    (1883,'岳阳县',1879),
    (1884,'华容县',1879),
    (1885,'湘阴县',1879),
    (1886,'平江县',1879),
    (1887,'汨罗市',1879),
    (1888,'临湘市',1879),
    (1889,'常德市',1826),
    (1890,'武陵区',1889),
    (1891,'鼎城区',1889),
    (1892,'安乡县',1889),
    (1893,'汉寿县',1889),
    (1894,'澧县',1889),
    (1895,'临澧县',1889),
    (1896,'桃源县',1889),
    (1897,'石门县',1889),
    (1898,'津市市',1889),
    (1899,'张家界市',1826),
    (1900,'永定区',1899),
    (1901,'武陵源区',1899),
    (1902,'慈利县',1899),
    (1903,'桑植县',1899),
    (1904,'益阳市',1826),
    (1905,'资阳区',1904),
    (1906,'赫山区',1904),
    (1907,'南县',1904),
    (1908,'桃江县',1904),
    (1909,'安化县',1904),
    (1910,'沅江市',1904),
    (1911,'郴州市',1826),
    (1912,'北湖区',1911),
    (1913,'苏仙区',1911),
    (1914,'桂阳县',1911),
    (1915,'宜章县',1911),
    (1916,'永兴县',1911),
    (1917,'嘉禾县',1911),
    (1918,'临武县',1911),
    (1919,'汝城县',1911),
    (1920,'桂东县',1911),
    (1921,'安仁县',1911),
    (1922,'资兴市',1911),
    (1923,'永州市',1826),
    (1924,'零陵区',1923),
    (1925,'冷水滩区',1923),
    (1926,'祁阳县',1923),
    (1927,'东安县',1923),
    (1928,'双牌县',1923),
    (1929,'道县',1923),
    (1930,'江永县',1923),
    (1931,'宁远县',1923),
    (1932,'蓝山县',1923),
    (1933,'新田县',1923),
    (1934,'江华瑶族自治县',1923),
    (1935,'怀化市',1826),
    (1936,'鹤城区',1935),
    (1937,'中方县',1935),
    (1938,'沅陵县',1935),
    (1939,'辰溪县',1935),
    (1940,'溆浦县',1935),
    (1941,'会同县',1935),
    (1942,'麻阳苗族自治县',1935),
    (1943,'新晃侗族自治县',1935),
    (1944,'芷江侗族自治县',1935),
    (1945,'靖州苗族侗族自治县',1935),
    (1946,'通道侗族自治县',1935),
    (1947,'洪江市',1935),
    (1948,'娄底市',1826),
    (1949,'娄星区',1948),
    (1950,'双峰县',1948),
    (1951,'新化县',1948),
    (1952,'冷水江市',1948),
    (1953,'涟源市',1948),
    (1954,'湘西土家族苗族自治州',1826),
    (1955,'吉首市',1954),
    (1956,'泸溪县',1954),
    (1957,'凤凰县',1954),
    (1958,'花垣县',1954),
    (1959,'保靖县',1954),
    (1960,'古丈县',1954),
    (1961,'永顺县',1954),
    (1962,'龙山县',1954),
    (1963,'广东',0),
    (1964,'广州市',1963),
    (1965,'荔湾区',1964),
    (1966,'越秀区',1964),
    (1967,'海珠区',1964),
    (1968,'天河区',1964),
    (1969,'白云区',1964),
    (1970,'黄埔区',1964),
    (1971,'番禺区',1964),
    (1972,'花都区',1964),
    (1973,'南沙区',1964),
    (1974,'萝岗区',1964),
    (1975,'增城市',1964),
    (1976,'从化市',1964),
    (1977,'韶关市',1963),
    (1978,'武江区',1977),
    (1979,'浈江区',1977),
    (1980,'曲江区',1977),
    (1981,'始兴县',1977),
    (1982,'仁化县',1977),
    (1983,'翁源县',1977),
    (1984,'乳源瑶族自治县',1977),
    (1985,'新丰县',1977),
    (1986,'乐昌市',1977),
    (1987,'南雄市',1977),
    (1988,'深圳市',1963),
    (1989,'罗湖区',1988),
    (1990,'福田区',1988),
    (1991,'南山区',1988),
    (1992,'宝安区',1988),
    (1993,'龙岗区',1988),
    (1994,'盐田区',1988),
    (1995,'珠海市',1963),
    (1996,'香洲区',1995),
    (1997,'斗门区',1995),
    (1998,'金湾区',1995),
    (1999,'汕头市',1963),
    (2000,'龙湖区',1999),
    (2001,'金平区',1999),
    (2002,'濠江区',1999),
    (2003,'潮阳区',1999),
    (2004,'潮南区',1999),
    (2005,'澄海区',1999),
    (2006,'南澳县',1999),
    (2007,'佛山市',1963),
    (2008,'禅城区',2007),
    (2009,'南海区',2007),
    (2010,'顺德区',2007),
    (2011,'三水区',2007),
    (2012,'高明区',2007),
    (2013,'江门市',1963),
    (2014,'蓬江区',2013),
    (2015,'江海区',2013),
    (2016,'新会区',2013),
    (2017,'台山市',2013),
    (2018,'开平市',2013),
    (2019,'鹤山市',2013),
    (2020,'恩平市',2013),
    (2021,'湛江市',1963),
    (2022,'赤坎区',2021),
    (2023,'霞山区',2021),
    (2024,'坡头区',2021),
    (2025,'麻章区',2021),
    (2026,'遂溪县',2021),
    (2027,'徐闻县',2021),
    (2028,'廉江市',2021),
    (2029,'雷州市',2021),
    (2030,'吴川市',2021),
    (2031,'茂名市',1963),
    (2032,'茂南区',2031),
    (2033,'茂港区',2031),
    (2034,'电白县',2031),
    (2035,'高州市',2031),
    (2036,'化州市',2031),
    (2037,'信宜市',2031),
    (2038,'肇庆市',1963),
    (2039,'端州区',2038),
    (2040,'鼎湖区',2038),
    (2041,'广宁县',2038),
    (2042,'怀集县',2038),
    (2043,'封开县',2038),
    (2044,'德庆县',2038),
    (2045,'高要市',2038),
    (2046,'四会市',2038),
    (2047,'惠州市',1963),
    (2048,'惠城区',2047),
    (2049,'惠阳区',2047),
    (2050,'博罗县',2047),
    (2051,'惠东县',2047),
    (2052,'龙门县',2047),
    (2053,'梅州市',1963),
    (2054,'梅江区',2053),
    (2055,'梅县',2053),
    (2056,'大埔县',2053),
    (2057,'丰顺县',2053),
    (2058,'五华县',2053),
    (2059,'平远县',2053),
    (2060,'蕉岭县',2053),
    (2061,'兴宁市',2053),
    (2062,'汕尾市',1963),
    (2063,'城区',2062),
    (2064,'海丰县',2062),
    (2065,'陆河县',2062),
    (2066,'陆丰市',2062),
    (2067,'河源市',1963),
    (2068,'源城区',2067),
    (2069,'紫金县',2067),
    (2070,'龙川县',2067),
    (2071,'连平县',2067),
    (2072,'和平县',2067),
    (2073,'东源县',2067),
    (2074,'阳江市',1963),
    (2075,'江城区',2074),
    (2076,'阳西县',2074),
    (2077,'阳东县',2074),
    (2078,'阳春市',2074),
    (2079,'清远市',1963),
    (2080,'清城区',2079),
    (2081,'佛冈县',2079),
    (2082,'阳山县',2079),
    (2083,'连山壮族瑶族自治县',2079),
    (2084,'连南瑶族自治县',2079),
    (2085,'清新县',2079),
    (2086,'英德市',2079),
    (2087,'连州市',2079),
    (2088,'东莞市',1963),
    (2089,'中山市',1963),
    (2090,'潮州市',1963),
    (2091,'湘桥区',2090),
    (2092,'潮安县',2090),
    (2093,'饶平县',2090),
    (2094,'揭阳市',1963),
    (2095,'榕城区',2094),
    (2096,'揭东县',2094),
    (2097,'揭西县',2094),
    (2098,'惠来县',2094),
    (2099,'普宁市',2094),
    (2100,'云浮市',1963),
    (2101,'云城区',2100),
    (2102,'新兴县',2100),
    (2103,'郁南县',2100),
    (2104,'云安县',2100),
    (2105,'罗定市',2100),
    (2106,'广西',0),
    (2107,'南宁市',2106),
    (2108,'兴宁区',2107),
    (2109,'青秀区',2107),
    (2110,'江南区',2107),
    (2111,'西乡塘区',2107),
    (2112,'良庆区',2107),
    (2113,'邕宁区',2107),
    (2114,'武鸣县',2107),
    (2115,'隆安县',2107),
    (2116,'马山县',2107),
    (2117,'上林县',2107),
    (2118,'宾阳县',2107),
    (2119,'横县',2107),
    (2120,'柳州市',2106),
    (2121,'城中区',2120),
    (2122,'鱼峰区',2120),
    (2123,'柳南区',2120),
    (2124,'柳北区',2120),
    (2125,'柳江县',2120),
    (2126,'柳城县',2120),
    (2127,'鹿寨县',2120),
    (2128,'融安县',2120),
    (2129,'融水苗族自治县',2120),
    (2130,'三江侗族自治县',2120),
    (2131,'桂林市',2106),
    (2132,'秀峰区',2131),
    (2133,'叠彩区',2131),
    (2134,'象山区',2131),
    (2135,'七星区',2131),
    (2136,'雁山区',2131),
    (2137,'阳朔县',2131),
    (2138,'临桂县',2131),
    (2139,'灵川县',2131),
    (2140,'全州县',2131),
    (2141,'兴安县',2131),
    (2142,'永福县',2131),
    (2143,'灌阳县',2131),
    (2144,'龙胜各族自治县',2131),
    (2145,'资源县',2131),
    (2146,'平乐县',2131),
    (2147,'荔蒲县',2131),
    (2148,'恭城瑶族自治县',2131),
    (2149,'梧州市',2106),
    (2150,'万秀区',2149),
    (2151,'蝶山区',2149),
    (2152,'长洲区',2149),
    (2153,'苍梧县',2149),
    (2154,'藤县',2149),
    (2155,'蒙山县',2149),
    (2156,'岑溪市',2149),
    (2157,'北海市',2106),
    (2158,'海城区',2157),
    (2159,'银海区',2157),
    (2160,'铁山港区',2157),
    (2161,'合浦县',2157),
    (2162,'防城港市',2106),
    (2163,'港口区',2162),
    (2164,'防城区',2162),
    (2165,'上思县',2162),
    (2166,'东兴市',2162),
    (2167,'钦州市',2106),
    (2168,'钦南区',2167),
    (2169,'钦北区',2167),
    (2170,'灵山县',2167),
    (2171,'浦北县',2167),
    (2172,'贵港市',2106),
    (2173,'港北区',2172),
    (2174,'港南区',2172),
    (2175,'覃塘区',2172),
    (2176,'平南县',2172),
    (2177,'桂平市',2172),
    (2178,'玉林市',2106),
    (2179,'玉州区',2178),
    (2180,'容县',2178),
    (2181,'陆川县',2178),
    (2182,'博白县',2178),
    (2183,'兴业县',2178),
    (2184,'北流市',2178),
    (2185,'百色市',2106),
    (2186,'右江区',2185),
    (2187,'田阳县',2185),
    (2188,'田东县',2185),
    (2189,'平果县',2185),
    (2190,'德保县',2185),
    (2191,'靖西县',2185),
    (2192,'那坡县',2185),
    (2193,'凌云县',2185),
    (2194,'乐业县',2185),
    (2195,'田林县',2185),
    (2196,'西林县',2185),
    (2197,'隆林各族自治县',2185),
    (2198,'贺州市',2106),
    (2199,'八步区',2198),
    (2200,'昭平县',2198),
    (2201,'钟山县',2198),
    (2202,'富川瑶族自治县',2198),
    (2203,'河池市',2106),
    (2204,'金城江区',2203),
    (2205,'南丹县',2203),
    (2206,'天峨县',2203),
    (2207,'凤山县',2203),
    (2208,'东兰县',2203),
    (2209,'罗城仫佬族自治县',2203),
    (2210,'环江毛南族自治县',2203),
    (2211,'巴马瑶族自治县',2203),
    (2212,'都安瑶族自治县',2203),
    (2213,'大化瑶族自治县',2203),
    (2214,'宜州市',2203),
    (2215,'来宾市',2106),
    (2216,'兴宾区',2215),
    (2217,'忻城县',2215),
    (2218,'象州县',2215),
    (2219,'武宣县',2215),
    (2220,'金秀瑶族自治县',2215),
    (2221,'合山市',2215),
    (2222,'崇左市',2106),
    (2223,'江洲区',2222),
    (2224,'扶绥县',2222),
    (2225,'宁明县',2222),
    (2226,'龙州县',2222),
    (2227,'大新县',2222),
    (2228,'天等县',2222),
    (2229,'凭祥市',2222),
    (2230,'海南',0),
    (2231,'海口市',2230),
    (2232,'秀英区',2231),
    (2233,'龙华区',2231),
    (2234,'琼山区',2231),
    (2235,'美兰区',2231),
    (2236,'三亚市',2230),
    (2237,'省直辖县级行政单位',2230),
    (2238,'五指山市',2237),
    (2239,'琼海市',2237),
    (2240,'儋州市',2237),
    (2241,'文昌市',2237),
    (2242,'万宁市',2237),
    (2243,'东方市',2237),
    (2244,'定安县',2237),
    (2245,'屯昌县',2237),
    (2246,'澄迈县',2237),
    (2247,'临高县',2237),
    (2248,'白沙黎族自治县',2237),
    (2249,'昌江黎族自治县',2237),
    (2250,'乐东黎族自治县',2237),
    (2251,'陵水黎族自治县',2237),
    (2252,'保亭黎族苗族自治县',2237),
    (2253,'琼中黎族苗族自治县',2237),
    (2254,'西沙群岛',2237),
    (2255,'南沙群岛',2237),
    (2256,'中沙群岛的岛礁及其海域',2237),
    (2257,'重庆市',0),
    (2258,'重庆市',2257),
    (2259,'万州区',2258),
    (2260,'涪陵区',2258),
    (2261,'渝中区',2258),
    (2262,'大渡口区',2258),
    (2263,'江北区',2258),
    (2264,'沙坪坝区',2258),
    (2265,'九龙坡区',2258),
    (2266,'南岸区',2258),
    (2267,'北碚区',2258),
    (2268,'万盛区',2258),
    (2269,'双桥区',2258),
    (2270,'渝北区',2258),
    (2271,'巴南区',2258),
    (2272,'黔江区',2258),
    (2273,'长寿区',2258),
    (2274,'江津区',2258),
    (2275,'合川区',2258),
    (2276,'永川区',2258),
    (2277,'南川区',2258),
    (2278,'綦江县',2258),
    (2279,'潼南县',2258),
    (2280,'铜梁县',2258),
    (2281,'大足县',2258),
    (2282,'荣昌县',2258),
    (2283,'璧山县',2258),
    (2284,'梁平县',2258),
    (2285,'城口县',2258),
    (2286,'丰都县',2258),
    (2287,'垫江县',2258),
    (2288,'武隆县',2258),
    (2289,'忠县',2258),
    (2290,'开县',2258),
    (2291,'云阳县',2258),
    (2292,'奉节县',2258),
    (2293,'巫山县',2258),
    (2294,'巫溪县',2258),
    (2295,'石柱土家族自治县',2258),
    (2296,'秀山土家族苗族自治县',2258),
    (2297,'酉阳土家族苗族自治县',2258),
    (2298,'彭水苗族土家族自治县',2258),
    (2299,'四川',0),
    (2300,'成都市',2299),
    (2301,'锦江区',2300),
    (2302,'青羊区',2300),
    (2303,'金牛区',2300),
    (2304,'武侯区',2300),
    (2305,'成华区',2300),
    (2306,'龙泉驿区',2300),
    (2307,'青白江区',2300),
    (2308,'新都区',2300),
    (2309,'温江区',2300),
    (2310,'金堂县',2300),
    (2311,'双流县',2300),
    (2312,'郫县',2300),
    (2313,'大邑县',2300),
    (2314,'蒲江县',2300),
    (2315,'新津县',2300),
    (2316,'都江堰市',2300),
    (2317,'彭州市',2300),
    (2318,'邛崃市',2300),
    (2319,'崇州市',2300),
    (2320,'自贡市',2299),
    (2321,'自流井区',2320),
    (2322,'贡井区',2320),
    (2323,'大安区',2320),
    (2324,'沿滩区',2320),
    (2325,'荣县',2320),
    (2326,'富顺县',2320),
    (2327,'攀枝花市',2299),
    (2328,'东区',2327),
    (2329,'西区',2327),
    (2330,'仁和区',2327),
    (2331,'米易县',2327),
    (2332,'盐边县',2327),
    (2333,'泸州市',2299),
    (2334,'江阳区',2333),
    (2335,'纳溪区',2333),
    (2336,'龙马潭区',2333),
    (2337,'泸县',2333),
    (2338,'合江县',2333),
    (2339,'叙永县',2333),
    (2340,'古蔺县',2333),
    (2341,'德阳市',2299),
    (2342,'旌阳区',2341),
    (2343,'中江县',2341),
    (2344,'罗江县',2341),
    (2345,'广汉市',2341),
    (2346,'什邡市',2341),
    (2347,'绵竹市',2341),
    (2348,'绵阳市',2299),
    (2349,'涪城区',2348),
    (2350,'游仙区',2348),
    (2351,'三台县',2348),
    (2352,'盐亭县',2348),
    (2353,'安县',2348),
    (2354,'梓潼县',2348),
    (2355,'北川羌族自治县',2348),
    (2356,'平武县',2348),
    (2357,'江油市',2348),
    (2358,'广元市',2299),
    (2359,'市中区',2358),
    (2360,'元坝区',2358),
    (2361,'朝天区',2358),
    (2362,'旺苍县',2358),
    (2363,'青川县',2358),
    (2364,'剑阁县',2358),
    (2365,'苍溪县',2358),
    (2366,'遂宁市',2299),
    (2367,'船山区',2366),
    (2368,'安居区',2366),
    (2369,'蓬溪县',2366),
    (2370,'射洪县',2366),
    (2371,'大英县',2366),
    (2372,'内江市',2299),
    (2373,'市中区',2372),
    (2374,'东兴区',2372),
    (2375,'威远县',2372),
    (2376,'资中县',2372),
    (2377,'隆昌县',2372),
    (2378,'乐山市',2299),
    (2379,'市中区',2378),
    (2380,'沙湾区',2378),
    (2381,'五通桥区',2378),
    (2382,'金口河区',2378),
    (2383,'犍为县',2378),
    (2384,'井研县',2378),
    (2385,'夹江县',2378),
    (2386,'沐川县',2378),
    (2387,'峨边彝族自治县',2378),
    (2388,'马边彝族自治县',2378),
    (2389,'峨眉山市',2378),
    (2390,'南充市',2299),
    (2391,'顺庆区',2390),
    (2392,'高坪区',2390),
    (2393,'嘉陵区',2390),
    (2394,'南部县',2390),
    (2395,'营山县',2390),
    (2396,'蓬安县',2390),
    (2397,'仪陇县',2390),
    (2398,'西充县',2390),
    (2399,'阆中市',2390),
    (2400,'眉山市',2299),
    (2401,'东坡区',2400),
    (2402,'仁寿县',2400),
    (2403,'彭山县',2400),
    (2404,'洪雅县',2400),
    (2405,'丹棱县',2400),
    (2406,'青神县',2400),
    (2407,'宜宾市',2299),
    (2408,'翠屏区',2407),
    (2409,'宜宾县',2407),
    (2410,'南溪县',2407),
    (2411,'江安县',2407),
    (2412,'长宁县',2407),
    (2413,'高县',2407),
    (2414,'珙县',2407),
    (2415,'筠连县',2407),
    (2416,'兴文县',2407),
    (2417,'屏山县',2407),
    (2418,'广安市',2299),
    (2419,'广安区',2418),
    (2420,'岳池县',2418),
    (2421,'武胜县',2418),
    (2422,'邻水县',2418),
    (2423,'华蓥市',2418),
    (2424,'达州市',2299),
    (2425,'通川区',2424),
    (2426,'达县',2424),
    (2427,'宣汉县',2424),
    (2428,'开江县',2424),
    (2429,'大竹县',2424),
    (2430,'渠县',2424),
    (2431,'万源市',2424),
    (2432,'雅安市',2299),
    (2433,'雨城区',2432),
    (2434,'名山县',2432),
    (2435,'荥经县',2432),
    (2436,'汉源县',2432),
    (2437,'石棉县',2432),
    (2438,'天全县',2432),
    (2439,'芦山县',2432),
    (2440,'宝兴县',2432),
    (2441,'巴中市',2299),
    (2442,'巴州区',2441),
    (2443,'通江县',2441),
    (2444,'南江县',2441),
    (2445,'平昌县',2441),
    (2446,'资阳市',2299),
    (2447,'雁江区',2446),
    (2448,'安岳县',2446),
    (2449,'乐至县',2446),
    (2450,'简阳市',2446),
    (2451,'阿坝藏族羌族自治州',2299),
    (2452,'汶川县',2451),
    (2453,'理县',2451),
    (2454,'茂县',2451),
    (2455,'松潘县',2451),
    (2456,'九寨沟县',2451),
    (2457,'金川县',2451),
    (2458,'小金县',2451),
    (2459,'黑水县',2451),
    (2460,'马尔康县',2451),
    (2461,'壤塘县',2451),
    (2462,'阿坝县',2451),
    (2463,'若尔盖县',2451),
    (2464,'红原县',2451),
    (2465,'甘孜藏族自治州',2299),
    (2466,'康定县',2465),
    (2467,'泸定县',2465),
    (2468,'丹巴县',2465),
    (2469,'九龙县',2465),
    (2470,'雅江县',2465),
    (2471,'道孚县',2465),
    (2472,'炉霍县',2465),
    (2473,'甘孜县',2465),
    (2474,'新龙县',2465),
    (2475,'德格县',2465),
    (2476,'白玉县',2465),
    (2477,'石渠县',2465),
    (2478,'色达县',2465),
    (2479,'理塘县',2465),
    (2480,'巴塘县',2465),
    (2481,'乡城县',2465),
    (2482,'稻城县',2465),
    (2483,'得荣县',2465),
    (2484,'凉山彝族自治州',2299),
    (2485,'西昌市',2484),
    (2486,'木里藏族自治县',2484),
    (2487,'盐源县',2484),
    (2488,'德昌县',2484),
    (2489,'会理县',2484),
    (2490,'会东县',2484),
    (2491,'宁南县',2484),
    (2492,'普格县',2484),
    (2493,'布拖县',2484),
    (2494,'金阳县',2484),
    (2495,'昭觉县',2484),
    (2496,'喜德县',2484),
    (2497,'冕宁县',2484),
    (2498,'越西县',2484),
    (2499,'甘洛县',2484),
    (2500,'美姑县',2484),
    (2501,'雷波县',2484),
    (2502,'贵州',0),
    (2503,'贵阳市',2502),
    (2504,'南明区',2503),
    (2505,'云岩区',2503),
    (2506,'花溪区',2503),
    (2507,'乌当区',2503),
    (2508,'白云区',2503),
    (2509,'小河区',2503),
    (2510,'开阳县',2503),
    (2511,'息烽县',2503),
    (2512,'修文县',2503),
    (2513,'清镇市',2503),
    (2514,'六盘水市',2502),
    (2515,'钟山区',2514),
    (2516,'六枝特区',2514),
    (2517,'水城县',2514),
    (2518,'盘县',2514),
    (2519,'遵义市',2502),
    (2520,'红花岗区',2519),
    (2521,'汇川区',2519),
    (2522,'遵义县',2519),
    (2523,'桐梓县',2519),
    (2524,'绥阳县',2519),
    (2525,'正安县',2519),
    (2526,'道真仡佬族苗族自治县',2519),
    (2527,'务川仡佬族苗族自治县',2519),
    (2528,'凤冈县',2519),
    (2529,'湄潭县',2519),
    (2530,'余庆县',2519),
    (2531,'习水县',2519),
    (2532,'赤水市',2519),
    (2533,'仁怀市',2519),
    (2534,'安顺市',2502),
    (2535,'西秀区',2534),
    (2536,'平坝县',2534),
    (2537,'普定县',2534),
    (2538,'镇宁布依族苗族自治县',2534),
    (2539,'关岭布依族苗族自治县',2534),
    (2540,'紫云苗族布依族自治县',2534),
    (2541,'铜仁地区',2502),
    (2542,'铜仁市',2541),
    (2543,'江口县',2541),
    (2544,'玉屏侗族自治县',2541),
    (2545,'石阡县',2541),
    (2546,'思南县',2541),
    (2547,'印江土家族苗族自治县',2541),
    (2548,'德江县',2541),
    (2549,'沿河土家族自治县',2541),
    (2550,'松桃苗族自治县',2541),
    (2551,'万山特区',2541),
    (2552,'黔西南布依族苗族自治州',2502),
    (2553,'兴义市',2552),
    (2554,'兴仁县',2552),
    (2555,'普安县',2552),
    (2556,'晴隆县',2552),
    (2557,'贞丰县',2552),
    (2558,'望谟县',2552),
    (2559,'册亨县',2552),
    (2560,'安龙县',2552),
    (2561,'毕节地区',2502),
    (2562,'毕节市',2561),
    (2563,'大方县',2561),
    (2564,'黔西县',2561),
    (2565,'金沙县',2561),
    (2566,'织金县',2561),
    (2567,'纳雍县',2561),
    (2568,'威宁彝族回族苗族自治县',2561),
    (2569,'赫章县',2561),
    (2570,'黔东南苗族侗族自治州',2502),
    (2571,'凯里市',2570),
    (2572,'黄平县',2570),
    (2573,'施秉县',2570),
    (2574,'三穗县',2570),
    (2575,'镇远县',2570),
    (2576,'岑巩县',2570),
    (2577,'天柱县',2570),
    (2578,'锦屏县',2570),
    (2579,'剑河县',2570),
    (2580,'台江县',2570),
    (2581,'黎平县',2570),
    (2582,'榕江县',2570),
    (2583,'从江县',2570),
    (2584,'雷山县',2570),
    (2585,'麻江县',2570),
    (2586,'丹寨县',2570),
    (2587,'黔南布依族苗族自治州',2502),
    (2588,'都匀市',2587),
    (2589,'福泉市',2587),
    (2590,'荔波县',2587),
    (2591,'贵定县',2587),
    (2592,'瓮安县',2587),
    (2593,'独山县',2587),
    (2594,'平塘县',2587),
    (2595,'罗甸县',2587),
    (2596,'长顺县',2587),
    (2597,'龙里县',2587),
    (2598,'惠水县',2587),
    (2599,'三都水族自治县',2587),
    (2600,'云南',0),
    (2601,'昆明市',2600),
    (2602,'五华区',2601),
    (2603,'盘龙区',2601),
    (2604,'官渡区',2601),
    (2605,'西山区',2601),
    (2606,'东川区',2601),
    (2607,'呈贡县',2601),
    (2608,'晋宁县',2601),
    (2609,'富民县',2601),
    (2610,'宜良县',2601),
    (2611,'石林彝族自治县',2601),
    (2612,'嵩明县',2601),
    (2613,'禄劝彝族苗族自治县',2601),
    (2614,'寻甸回族彝族自治县',2601),
    (2615,'安宁市',2601),
    (2616,'曲靖市',2600),
    (2617,'麒麟区',2616),
    (2618,'马龙县',2616),
    (2619,'陆良县',2616),
    (2620,'师宗县',2616),
    (2621,'罗平县',2616),
    (2622,'富源县',2616),
    (2623,'会泽县',2616),
    (2624,'沾益县',2616),
    (2625,'宣威市',2616),
    (2626,'玉溪市',2600),
    (2627,'红塔区',2626),
    (2628,'江川县',2626),
    (2629,'澄江县',2626),
    (2630,'通海县',2626),
    (2631,'华宁县',2626),
    (2632,'易门县',2626),
    (2633,'峨山彝族自治县',2626),
    (2634,'新平彝族傣族自治县',2626),
    (2635,'元江哈尼族彝族傣族自治县',2626),
    (2636,'保山市',2600),
    (2637,'隆阳区',2636),
    (2638,'施甸县',2636),
    (2639,'腾冲县',2636),
    (2640,'龙陵县',2636),
    (2641,'昌宁县',2636),
    (2642,'昭通市',2600),
    (2643,'昭阳区',2642),
    (2644,'鲁甸县',2642),
    (2645,'巧家县',2642),
    (2646,'盐津县',2642),
    (2647,'大关县',2642),
    (2648,'永善县',2642),
    (2649,'绥江县',2642),
    (2650,'镇雄县',2642),
    (2651,'彝良县',2642),
    (2652,'威信县',2642),
    (2653,'水富县',2642),
    (2654,'丽江市',2600),
    (2655,'古城区',2654),
    (2656,'玉龙纳西族自治县',2654),
    (2657,'永胜县',2654),
    (2658,'华坪县',2654),
    (2659,'宁蒗彝族自治县',2654),
    (2660,'普洱市',2600),
    (2661,'思茅区',2660),
    (2662,'宁洱哈尼族彝族自治县',2660),
    (2663,'墨江哈尼族自治县',2660),
    (2664,'景东彝族自治县',2660),
    (2665,'景谷傣族彝族自治县',2660),
    (2666,'镇沅彝族哈尼族拉祜族自治县',2660),
    (2667,'江城哈尼族彝族自治县',2660),
    (2668,'孟连傣族拉祜族佤族自治县',2660),
    (2669,'澜沧拉祜族自治县',2660),
    (2670,'西盟佤族自治县',2660),
    (2671,'临沧市',2600),
    (2672,'临翔区',2671),
    (2673,'凤庆县',2671),
    (2674,'云县',2671),
    (2675,'永德县',2671),
    (2676,'镇康县',2671),
    (2677,'双江拉祜族佤族布朗族傣族自治县',2671),
    (2678,'耿马傣族佤族自治县',2671),
    (2679,'沧源佤族自治县',2671),
    (2680,'楚雄彝族自治州',2600),
    (2681,'楚雄市',2680),
    (2682,'双柏县',2680),
    (2683,'牟定县',2680),
    (2684,'南华县',2680),
    (2685,'姚安县',2680),
    (2686,'大姚县',2680),
    (2687,'永仁县',2680),
    (2688,'元谋县',2680),
    (2689,'武定县',2680),
    (2690,'禄丰县',2680),
    (2691,'红河哈尼族彝族自治州',2600),
    (2692,'个旧市',2691),
    (2693,'开远市',2691),
    (2694,'蒙自县',2691),
    (2695,'屏边苗族自治县',2691),
    (2696,'建水县',2691),
    (2697,'石屏县',2691),
    (2698,'弥勒县',2691),
    (2699,'泸西县',2691),
    (2700,'元阳县',2691),
    (2701,'红河县',2691),
    (2702,'金平苗族瑶族傣族自治县',2691),
    (2703,'绿春县',2691),
    (2704,'河口瑶族自治县',2691),
    (2705,'文山壮族苗族自治州',2600),
    (2706,'文山县',2705),
    (2707,'砚山县',2705),
    (2708,'西畴县',2705),
    (2709,'麻栗坡县',2705),
    (2710,'马关县',2705),
    (2711,'丘北县',2705),
    (2712,'广南县',2705),
    (2713,'富宁县',2705),
    (2714,'西双版纳傣族自治州',2600),
    (2715,'景洪市',2714),
    (2716,'勐海县',2714),
    (2717,'勐腊县',2714),
    (2718,'大理白族自治州',2600),
    (2719,'大理市',2718),
    (2720,'漾濞彝族自治县',2718),
    (2721,'祥云县',2718),
    (2722,'宾川县',2718),
    (2723,'弥渡县',2718),
    (2724,'南涧彝族自治县',2718),
    (2725,'巍山彝族回族自治县',2718),
    (2726,'永平县',2718),
    (2727,'云龙县',2718),
    (2728,'洱源县',2718),
    (2729,'剑川县',2718),
    (2730,'鹤庆县',2718),
    (2731,'德宏傣族景颇族自治州',2600),
    (2732,'瑞丽市',2731),
    (2733,'潞西市',2731),
    (2734,'梁河县',2731),
    (2735,'盈江县',2731),
    (2736,'陇川县',2731),
    (2737,'怒江傈僳族自治州',2600),
    (2738,'泸水县',2737),
    (2739,'福贡县',2737),
    (2740,'贡山独龙族怒族自治县',2737),
    (2741,'兰坪白族普米族自治县',2737),
    (2742,'迪庆藏族自治州',2600),
    (2743,'香格里拉县',2742),
    (2744,'德钦县',2742),
    (2745,'维西傈僳族自治县',2742),
    (2746,'西藏',0),
    (2747,'拉萨市',2746),
    (2748,'城关区',2747),
    (2749,'林周县',2747),
    (2750,'当雄县',2747),
    (2751,'尼木县',2747),
    (2752,'曲水县',2747),
    (2753,'堆龙德庆县',2747),
    (2754,'达孜县',2747),
    (2755,'墨竹工卡县',2747),
    (2756,'昌都地区',2746),
    (2757,'昌都县',2756),
    (2758,'江达县',2756),
    (2759,'贡觉县',2756),
    (2760,'类乌齐县',2756),
    (2761,'丁青县',2756),
    (2762,'察雅县',2756),
    (2763,'八宿县',2756),
    (2764,'左贡县',2756),
    (2765,'芒康县',2756),
    (2766,'洛隆县',2756),
    (2767,'边坝县',2756),
    (2768,'山南地区',2746),
    (2769,'乃东县',2768),
    (2770,'扎囊县',2768),
    (2771,'贡嘎县',2768),
    (2772,'桑日县',2768),
    (2773,'琼结县',2768),
    (2774,'曲松县',2768),
    (2775,'措美县',2768),
    (2776,'洛扎县',2768),
    (2777,'加查县',2768),
    (2778,'隆子县',2768),
    (2779,'错那县',2768),
    (2780,'浪卡子县',2768),
    (2781,'日喀则地区',2746),
    (2782,'日喀则市',2781),
    (2783,'南木林县',2781),
    (2784,'江孜县',2781),
    (2785,'定日县',2781),
    (2786,'萨迦县',2781),
    (2787,'拉孜县',2781),
    (2788,'昂仁县',2781),
    (2789,'谢通门县',2781),
    (2790,'白朗县',2781),
    (2791,'仁布县',2781),
    (2792,'康马县',2781),
    (2793,'定结县',2781),
    (2794,'仲巴县',2781),
    (2795,'亚东县',2781),
    (2796,'吉隆县',2781),
    (2797,'聂拉木县',2781),
    (2798,'萨嘎县',2781),
    (2799,'岗巴县',2781),
    (2800,'那曲地区',2746),
    (2801,'那曲县',2800),
    (2802,'嘉黎县',2800),
    (2803,'比如县',2800),
    (2804,'聂荣县',2800),
    (2805,'安多县',2800),
    (2806,'申扎县',2800),
    (2807,'索县',2800),
    (2808,'班戈县',2800),
    (2809,'巴青县',2800),
    (2810,'尼玛县',2800),
    (2811,'阿里地区',2746),
    (2812,'普兰县',2811),
    (2813,'札达县',2811),
    (2814,'噶尔县',2811),
    (2815,'日土县',2811),
    (2816,'革吉县',2811),
    (2817,'改则县',2811),
    (2818,'措勤县',2811),
    (2819,'林芝地区',2746),
    (2820,'林芝县',2819),
    (2821,'工布江达县',2819),
    (2822,'米林县',2819),
    (2823,'墨脱县',2819),
    (2824,'波密县',2819),
    (2825,'察隅县',2819),
    (2826,'朗县',2819),
    (2827,'陕西',0),
    (2828,'西安市',2827),
    (2829,'新城区',2828),
    (2830,'碑林区',2828),
    (2831,'莲湖区',2828),
    (2832,'灞桥区',2828),
    (2833,'未央区',2828),
    (2834,'雁塔区',2828),
    (2835,'阎良区',2828),
    (2836,'临潼区',2828),
    (2837,'长安区',2828),
    (2838,'蓝田县',2828),
    (2839,'周至县',2828),
    (2840,'户县',2828),
    (2841,'高陵县',2828),
    (2842,'铜川市',2827),
    (2843,'王益区',2842),
    (2844,'印台区',2842),
    (2845,'耀州区',2842),
    (2846,'宜君县',2842),
    (2847,'宝鸡市',2827),
    (2848,'渭滨区',2847),
    (2849,'金台区',2847),
    (2850,'陈仓区',2847),
    (2851,'凤翔县',2847),
    (2852,'岐山县',2847),
    (2853,'扶风县',2847),
    (2854,'眉县',2847),
    (2855,'陇县',2847),
    (2856,'千阳县',2847),
    (2857,'麟游县',2847),
    (2858,'凤县',2847),
    (2859,'太白县',2847),
    (2860,'咸阳市',2827),
    (2861,'秦都区',2860),
    (2862,'杨凌区',2860),
    (2863,'渭城区',2860),
    (2864,'三原县',2860),
    (2865,'泾阳县',2860),
    (2866,'乾县',2860),
    (2867,'礼泉县',2860),
    (2868,'永寿县',2860),
    (2869,'彬县',2860),
    (2870,'长武县',2860),
    (2871,'旬邑县',2860),
    (2872,'淳化县',2860),
    (2873,'武功县',2860),
    (2874,'兴平市',2860),
    (2875,'渭南市',2827),
    (2876,'临渭区',2875),
    (2877,'华县',2875),
    (2878,'潼关县',2875),
    (2879,'大荔县',2875),
    (2880,'合阳县',2875),
    (2881,'澄城县',2875),
    (2882,'蒲城县',2875),
    (2883,'白水县',2875),
    (2884,'富平县',2875),
    (2885,'韩城市',2875),
    (2886,'华阴市',2875),
    (2887,'延安市',2827),
    (2888,'宝塔区',2887),
    (2889,'延长县',2887),
    (2890,'延川县',2887),
    (2891,'子长县',2887),
    (2892,'安塞县',2887),
    (2893,'志丹县',2887),
    (2894,'吴起县',2887),
    (2895,'甘泉县',2887),
    (2896,'富县',2887),
    (2897,'洛川县',2887),
    (2898,'宜川县',2887),
    (2899,'黄龙县',2887),
    (2900,'黄陵县',2887),
    (2901,'汉中市',2827),
    (2902,'汉台区',2901),
    (2903,'南郑县',2901),
    (2904,'城固县',2901),
    (2905,'洋县',2901),
    (2906,'西乡县',2901),
    (2907,'勉县',2901),
    (2908,'宁强县',2901),
    (2909,'略阳县',2901),
    (2910,'镇巴县',2901),
    (2911,'留坝县',2901),
    (2912,'佛坪县',2901),
    (2913,'榆林市',2827),
    (2914,'榆阳区',2913),
    (2915,'神木县',2913),
    (2916,'府谷县',2913),
    (2917,'横山县',2913),
    (2918,'靖边县',2913),
    (2919,'定边县',2913),
    (2920,'绥德县',2913),
    (2921,'米脂县',2913),
    (2922,'佳县',2913),
    (2923,'吴堡县',2913),
    (2924,'清涧县',2913),
    (2925,'子洲县',2913),
    (2926,'安康市',2827),
    (2927,'汉滨区',2926),
    (2928,'汉阴县',2926),
    (2929,'石泉县',2926),
    (2930,'宁陕县',2926),
    (2931,'紫阳县',2926),
    (2932,'岚皋县',2926),
    (2933,'平利县',2926),
    (2934,'镇坪县',2926),
    (2935,'旬阳县',2926),
    (2936,'白河县',2926),
    (2937,'商洛市',2827),
    (2938,'商州区',2937),
    (2939,'洛南县',2937),
    (2940,'丹凤县',2937),
    (2941,'商南县',2937),
    (2942,'山阳县',2937),
    (2943,'镇安县',2937),
    (2944,'柞水县',2937),
    (2945,'甘肃',0),
    (2946,'兰州市',2945),
    (2947,'城关区',2946),
    (2948,'七里河区',2946),
    (2949,'西固区',2946),
    (2950,'安宁区',2946),
    (2951,'红古区',2946),
    (2952,'永登县',2946),
    (2953,'皋兰县',2946),
    (2954,'榆中县',2946),
    (2955,'嘉峪关市',2945),
    (2956,'金昌市',2945),
    (2957,'金川区',2956),
    (2958,'永昌县',2956),
    (2959,'白银市',2945),
    (2960,'白银区',2959),
    (2961,'平川区',2959),
    (2962,'靖远县',2959),
    (2963,'会宁县',2959),
    (2964,'景泰县',2959),
    (2965,'天水市',2945),
    (2966,'秦州区',2965),
    (2967,'麦积区',2965),
    (2968,'清水县',2965),
    (2969,'秦安县',2965),
    (2970,'甘谷县',2965),
    (2971,'武山县',2965),
    (2972,'张家川回族自治县',2965),
    (2973,'武威市',2945),
    (2974,'凉州区',2973),
    (2975,'民勤县',2973),
    (2976,'古浪县',2973),
    (2977,'天祝藏族自治县',2973),
    (2978,'张掖市',2945),
    (2979,'甘州区',2978),
    (2980,'肃南裕固族自治县',2978),
    (2981,'民乐县',2978),
    (2982,'临泽县',2978),
    (2983,'高台县',2978),
    (2984,'山丹县',2978),
    (2985,'平凉市',2945),
    (2986,'崆峒区',2985),
    (2987,'泾川县',2985),
    (2988,'灵台县',2985),
    (2989,'崇信县',2985),
    (2990,'华亭县',2985),
    (2991,'庄浪县',2985),
    (2992,'静宁县',2985),
    (2993,'酒泉市',2945),
    (2994,'肃州区',2993),
    (2995,'金塔县',2993),
    (2996,'瓜州县',2993),
    (2997,'肃北蒙古族自治县',2993),
    (2998,'阿克塞哈萨克族自治县',2993),
    (2999,'玉门市',2993),
    (3000,'敦煌市',2993),
    (3001,'庆阳市',2945),
    (3002,'西峰区',3001),
    (3003,'庆城县',3001),
    (3004,'环县',3001),
    (3005,'华池县',3001),
    (3006,'合水县',3001),
    (3007,'正宁县',3001),
    (3008,'宁县',3001),
    (3009,'镇原县',3001),
    (3010,'定西市',2945),
    (3011,'安定区',3010),
    (3012,'通渭县',3010),
    (3013,'陇西县',3010),
    (3014,'渭源县',3010),
    (3015,'临洮县',3010),
    (3016,'漳县',3010),
    (3017,'岷县',3010),
    (3018,'陇南市',2945),
    (3019,'武都区',3018),
    (3020,'成县',3018),
    (3021,'文县',3018),
    (3022,'宕昌县',3018),
    (3023,'康县',3018),
    (3024,'西和县',3018),
    (3025,'礼县',3018),
    (3026,'徽县',3018),
    (3027,'两当县',3018),
    (3028,'临夏回族自治州',2945),
    (3029,'临夏市',3028),
    (3030,'临夏县',3028),
    (3031,'康乐县',3028),
    (3032,'永靖县',3028),
    (3033,'广河县',3028),
    (3034,'和政县',3028),
    (3035,'东乡族自治县',3028),
    (3036,'积石山保安族东乡族撒拉族自治县',3028),
    (3037,'甘南藏族自治州',2945),
    (3038,'合作市',3037),
    (3039,'临潭县',3037),
    (3040,'卓尼县',3037),
    (3041,'舟曲县',3037),
    (3042,'迭部县',3037),
    (3043,'玛曲县',3037),
    (3044,'碌曲县',3037),
    (3045,'夏河县',3037),
    (3046,'青海',0),
    (3047,'西宁市',3046),
    (3048,'城东区',3047),
    (3049,'城中区',3047),
    (3050,'城西区',3047),
    (3051,'城北区',3047),
    (3052,'大通回族土族自治县',3047),
    (3053,'湟中县',3047),
    (3054,'湟源县',3047),
    (3055,'海东地区',3046),
    (3056,'平安县',3055),
    (3057,'民和回族土族自治县',3055),
    (3058,'乐都县',3055),
    (3059,'互助土族自治县',3055),
    (3060,'化隆回族自治县',3055),
    (3061,'循化撒拉族自治县',3055),
    (3062,'海北藏族自治州',3046),
    (3063,'门源回族自治县',3062),
    (3064,'祁连县',3062),
    (3065,'海晏县',3062),
    (3066,'刚察县',3062),
    (3067,'黄南藏族自治州',3046),
    (3068,'同仁县',3067),
    (3069,'尖扎县',3067),
    (3070,'泽库县',3067),
    (3071,'河南蒙古族自治县',3067),
    (3072,'海南藏族自治州',3046),
    (3073,'共和县',3072),
    (3074,'同德县',3072),
    (3075,'贵德县',3072),
    (3076,'兴海县',3072),
    (3077,'贵南县',3072),
    (3078,'果洛藏族自治州',3046),
    (3079,'玛沁县',3078),
    (3080,'班玛县',3078),
    (3081,'甘德县',3078),
    (3082,'达日县',3078),
    (3083,'久治县',3078),
    (3084,'玛多县',3078),
    (3085,'玉树藏族自治州',3046),
    (3086,'玉树县',3085),
    (3087,'杂多县',3085),
    (3088,'称多县',3085),
    (3089,'治多县',3085),
    (3090,'囊谦县',3085),
    (3091,'曲麻莱县',3085),
    (3092,'海西蒙古族藏族自治州',3046),
    (3093,'格尔木市',3092),
    (3094,'德令哈市',3092),
    (3095,'乌兰县',3092),
    (3096,'都兰县',3092),
    (3097,'天峻县',3092),
    (3098,'宁夏',0),
    (3099,'银川市',3098),
    (3100,'兴庆区',3099),
    (3101,'西夏区',3099),
    (3102,'金凤区',3099),
    (3103,'永宁县',3099),
    (3104,'贺兰县',3099),
    (3105,'灵武市',3099),
    (3106,'石嘴山市',3098),
    (3107,'大武口区',3106),
    (3108,'惠农区',3106),
    (3109,'平罗县',3106),
    (3110,'吴忠市',3098),
    (3111,'利通区',3110),
    (3112,'盐池县',3110),
    (3113,'同心县',3110),
    (3114,'青铜峡市',3110),
    (3115,'固原市',3098),
    (3116,'原州区',3115),
    (3117,'西吉县',3115),
    (3118,'隆德县',3115),
    (3119,'泾源县',3115),
    (3120,'彭阳县',3115),
    (3121,'中卫市',3098),
    (3122,'沙坡头区',3121),
    (3123,'中宁县',3121),
    (3124,'海原县',3121),
    (3125,'新疆',0),
    (3126,'乌鲁木齐市',3125),
    (3127,'天山区',3126),
    (3128,'沙依巴克区',3126),
    (3129,'新市区',3126),
    (3130,'水磨沟区',3126),
    (3131,'头屯河区',3126),
    (3132,'达坂城区',3126),
    (3133,'米东区',3126),
    (3134,'乌鲁木齐县',3126),
    (3135,'克拉玛依市',3125),
    (3136,'独山子区',3135),
    (3137,'克拉玛依区',3135),
    (3138,'白碱滩区',3135),
    (3139,'乌尔禾区',3135),
    (3140,'吐鲁番地区',3125),
    (3141,'吐鲁番市',3140),
    (3142,'鄯善县',3140),
    (3143,'托克逊县',3140),
    (3144,'哈密地区',3125),
    (3145,'昌吉回族自治州',3125),
    (3146,'昌吉市',3145),
    (3147,'阜康市',3145),
    (3148,'呼图壁县',3145),
    (3149,'玛纳斯县',3145),
    (3150,'奇台县',3145),
    (3151,'吉木萨尔县',3145),
    (3152,'木垒哈萨克自治县',3145),
    (3153,'博尔塔拉蒙古自治州',3125),
    (3154,'博乐市',3153),
    (3155,'精河县',3153),
    (3156,'温泉县',3153),
    (3157,'巴音郭楞蒙古自治州',3125),
    (3158,'库尔勒市',3157),
    (3159,'轮台县',3157),
    (3160,'尉犁县',3157),
    (3161,'若羌县',3157),
    (3162,'且末县',3157),
    (3163,'焉耆回族自治县',3157),
    (3164,'和静县',3157),
    (3165,'和硕县',3157),
    (3166,'博湖县',3157),
    (3167,'阿克苏地区',3125),
    (3168,'阿克苏市',3167),
    (3169,'温宿县',3167),
    (3170,'库车县',3167),
    (3171,'沙雅县',3167),
    (3172,'新和县',3167),
    (3173,'拜城县',3167),
    (3174,'乌什县',3167),
    (3175,'阿瓦提县',3167),
    (3176,'柯坪县',3167),
    (3177,'克孜勒苏柯尔克孜自治州',3125),
    (3178,'阿图什市',3177),
    (3179,'阿克陶县',3177),
    (3180,'阿合奇县',3177),
    (3181,'乌恰县',3177),
    (3182,'喀什地区',3125),
    (3183,'喀什市',3182),
    (3184,'疏附县',3182),
    (3185,'疏勒县',3182),
    (3186,'英吉沙县',3182),
    (3187,'泽普县',3182),
    (3188,'莎车县',3182),
    (3189,'叶城县',3182),
    (3190,'麦盖提县',3182),
    (3191,'岳普湖县',3182),
    (3192,'伽师县',3182),
    (3193,'巴楚县',3182),
    (3194,'塔什库尔干塔吉克自治县',3182),
    (3195,'和田地区',3125),
    (3196,'和田市',3195),
    (3197,'和田县',3195),
    (3198,'墨玉县',3195),
    (3199,'皮山县',3195),
    (3200,'洛浦县',3195),
    (3201,'策勒县',3195),
    (3202,'于田县',3195),
    (3203,'民丰县',3195),
    (3204,'伊犁哈萨克自治州',3125),
    (3205,'伊宁市',3204),
    (3206,'奎屯市',3204),
    (3207,'伊宁县',3204),
    (3208,'察布查尔锡伯自治县',3204),
    (3209,'霍城县',3204),
    (3210,'巩留县',3204),
    (3211,'新源县',3204),
    (3212,'昭苏县',3204),
    (3213,'特克斯县',3204),
    (3214,'尼勒克县',3204),
    (3215,'塔城地区',3125),
    (3216,'塔城市',3215),
    (3217,'乌苏市',3215),
    (3218,'额敏县',3215),
    (3219,'沙湾县',3215),
    (3220,'托里县',3215),
    (3221,'裕民县',3215),
    (3222,'和布克赛尔蒙古自治县',3215),
    (3223,'阿勒泰地区',3125),
    (3224,'阿勒泰市',3223),
    (3225,'布尔津县',3223),
    (3226,'富蕴县',3223),
    (3227,'福海县',3223),
    (3228,'哈巴河县',3223),
    (3229,'青河县',3223),
    (3230,'吉木乃县',3223),
    (3231,'石河子市',3223),
    (3232,'阿拉尔市',3223),
    (3233,'图木舒克市',3223),
    (3234,'五家渠',3223);

# Dump of table ts_attach
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_attach`;

CREATE TABLE `ts_attach` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `attach_type` varchar(50) NOT NULL DEFAULT 'attach',
  `userId` int(11) unsigned DEFAULT NULL,
  `uploadTime` int(11) unsigned DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `size` varchar(20) DEFAULT NULL,
  `extension` varchar(20) DEFAULT NULL,
  `hash` varchar(32) DEFAULT NULL,
  `private` tinyint(1) DEFAULT '0',
  `isDel` tinyint(1) DEFAULT '0',
  `savepath` varchar(255) DEFAULT NULL,
  `savename` varchar(255) DEFAULT NULL,
  `savedomain` tinyint(3) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `userId` (`userId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_category
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_category`;

CREATE TABLE `ts_category` (
  `id` int(4) NOT NULL AUTO_INCREMENT,
  `tid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `cleft` int(11) NOT NULL,
  `cright` int(11) NOT NULL,
  `corder` int(5) NOT NULL DEFAULT '0',
  `namespace` varchar(255) NOT NULL DEFAULT 'default',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_comment
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_comment`;

CREATE TABLE `ts_comment` (
  `id` int(11) NOT NULL auto_increment,
  `type` char(15) default NULL,
  `appid` int(11) default NULL,
  `appuid` int(11) default NULL,
  `name` varchar(30) default NULL,
  `uid` int(11) default NULL,
  `comment` text,
  `cTime` int(12) default NULL,
  `toId` int(11) NOT NULL default '0',
  `status` int(1) default '0',
  `quietly` tinyint(1) NOT NULL default '0',
  `to_uid` int(11) NOT NULL default '0',
  `data` text,
  PRIMARY KEY  (`id`),
  KEY `type` (`type`),
  KEY `appid` (`appid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;


# Dump of table ts_document
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_document`;

CREATE TABLE `ts_document` (
  `document_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `content` text,
  `author_id` int(11) DEFAULT NULL,
  `last_editor_id` int(11) DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL DEFAULT '1',
  `is_on_footer` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否在页脚显示',
  `ctime` int(11) DEFAULT NULL,
  `mtime` int(11) DEFAULT NULL,
  `display_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`document_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_document` DISABLE KEYS */;
INSERT INTO `ts_document` (`title`,`content`,`author_id`,`last_editor_id`,`is_active`,`is_on_footer`,`ctime`,`mtime`,`display_order`)
VALUES
	('官方社区','http://t.thinksns.com',4,4,1,1,1292213500,1292213500,1),
	('关于我们','&nbsp;&nbsp;&nbsp; ThinkSNS是国内最具潜力的互联网产品服务公司，为客户提供社会化网络产品、技术和服务在内的一系列解决方案和平台化网络建设。<br>&nbsp;&nbsp;&nbsp; ThinkSNS从一开始是就秉承优秀的软件开源思想，注重知识分享和团队协作，以一种开放、共赢、互利和友好的态度面向所有需要ThinkSNS，支持ThinkSNS，喜爱ThinkSNS的个人和社会团体。<br>&nbsp;&nbsp;&nbsp; ThinkSNS不单单是一个人性化的产品，同时也是整个公司灵魂化的象征，我们积聚创新，不断成长和完备，汲取更多先进性的技术革新，创造更具价值的优势产品，为更多ThinkSNS的应用爱好者提供动力支持和技术源泉。',4,4,1,1,1292213562,1292215236,2);

/*!40000 ALTER TABLE `ts_document` ENABLE KEYS */;


# Dump of table ts_expression
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_expression`;

CREATE TABLE `ts_expression` (
  `expression_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL DEFAULT 'miniblog',
  `emotion` varchar(255) NOT NULL,
  `filename` varchar(255) NOT NULL,
  PRIMARY KEY (`expression_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_expression` DISABLE KEYS */;
INSERT INTO `ts_expression` (`expression_id`,`title`,`type`,`emotion`,`filename`)
VALUES
	(1,'拥抱','miniblog','[拥抱]','hug.gif'),
	(2,'示爱','miniblog','[示爱]','kiss.gif'),
	(3,'呲牙','miniblog','[呲牙]','lol.gif'),
	(4,'可爱','miniblog','[可爱]','loveliness.gif'),
	(5,'折磨','miniblog','[折磨]','mad.gif'),
	(6,'难过','miniblog','[难过]','sad.gif'),
	(7,'流汗','miniblog','[流汗]','sweat.gif'),
	(8,'憨笑','miniblog','[憨笑]','biggrin.gif'),
	(9,'大哭','miniblog','[大哭]','cry.gif'),
	(10,'惊恐','miniblog','[惊恐]','funk.gif'),
	(11,'握手','miniblog','[握手]','handshake.gif'),
	(12,'发怒','miniblog','[发怒]','huffy.gif'),
	(13,'惊讶','miniblog','[惊讶]','shocked.gif'),
	(14,'害羞','miniblog','[害羞]','shy.gif'),
	(15,'微笑','miniblog','[微笑]','smile.gif'),
	(16,'偷笑','miniblog','[偷笑]','titter.gif'),
	(17,'调皮','miniblog','[调皮]','tongue.gif'),
	(18,'胜利','miniblog','[胜利]','victory.gif'),
	(19,'纠结','miniblog','[纠结]','jiujie.gif'),
	(20,'坏笑','miniblog','[坏笑]','badsmile.gif'),
	(21,'调戏','miniblog','[调戏]','tiaoxi.gif');

/*!40000 ALTER TABLE `ts_expression` ENABLE KEYS */;


# Dump of table ts_feed
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_feed`;

CREATE TABLE `ts_feed` (
  `feed_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `data` text NOT NULL,
  `ctime` int(11) NOT NULL,
  `type` varchar(120) NOT NULL,
  PRIMARY KEY (`feed_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_friend
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_friend`;

CREATE TABLE `ts_friend` (
  `friend_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `friend_uid` int(11) NOT NULL,
  `friend_uname` varchar(255) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `message` varchar(255) DEFAULT NULL,
  `ctime` int(11) NOT NULL,
  PRIMARY KEY (`friend_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_friend_group
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_friend_group`;

CREATE TABLE `ts_friend_group` (
  `friend_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  PRIMARY KEY (`friend_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_friend_group_link
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_friend_group_link`;

CREATE TABLE `ts_friend_group_link` (
  `uid` int(11) NOT NULL,
  `friend_uid` int(11) NOT NULL,
  `friend_uname` varchar(255) NOT NULL,
  `friend_group_id` int(11) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_invitecode
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_invitecode`;

CREATE TABLE `ts_invitecode` (
  `invite_code_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `code` varchar(120) NOT NULL,
  `is_used` tinyint(1) NOT NULL,
  `type` char(40) NOT NULL,
  `is_received` tinyint(1) NOT NULL,
  PRIMARY KEY (`invite_code_id`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_login
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_login`;

CREATE TABLE `ts_login` (
  `login_id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `type_uid` varchar(255) NOT NULL default '',
  `type` char(80) NOT NULL,
  `oauth_token` varchar(150) default NULL,
  `oauth_token_secret` varchar(150) default NULL,
  `is_sync` tinyint(1) NOT NULL,
  PRIMARY KEY  (`login_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_login_record
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_login_record`;

CREATE TABLE `ts_login_record` (
  `login_record_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `place` varchar(255) DEFAULT NULL,
  `ctime` int(11) DEFAULT NULL,
  PRIMARY KEY (`login_record_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_message
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_message`;

CREATE TABLE `ts_message` (
  `message_id` int(11) NOT NULL AUTO_INCREMENT,
  `from_uid` int(11) NOT NULL,
  `to_uid` int(11) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `content` text,
  `source_message_id` int(255) NOT NULL DEFAULT '0',
  `is_read` tinyint(1) NOT NULL DEFAULT '0',
  `is_lastest` tinyint(1) NOT NULL DEFAULT '1',
  `deleted_by` int(11) NOT NULL DEFAULT '0',
  `ctime` int(11) NOT NULL,
  PRIMARY KEY (`message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_myop_friendlog
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_myop_friendlog`;

CREATE TABLE `ts_myop_friendlog` (
  `uid` int(11) NOT NULL,
  `fuid` int(11) NOT NULL,
  `action` varchar(255) NOT NULL,
  `dateline` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_myop_myapp
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_myop_myapp`;

CREATE TABLE `ts_myop_myapp` (
  `appid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `appname` varchar(60) NOT NULL DEFAULT '',
  `narrow` tinyint(1) NOT NULL DEFAULT '0',
  `flag` tinyint(1) NOT NULL DEFAULT '0',
  `version` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `displaymethod` tinyint(1) NOT NULL DEFAULT '0',
  `displayorder` smallint(6) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`appid`),
  KEY `flag` (`flag`,`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_myop_myinvite
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_myop_myinvite`;

CREATE TABLE `ts_myop_myinvite` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `typename` varchar(100) NOT NULL DEFAULT '',
  `appid` mediumint(8) NOT NULL DEFAULT '0',
  `type` tinyint(1) NOT NULL DEFAULT '0',
  `fromuid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `touid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `myml` text NOT NULL,
  `dateline` int(10) unsigned NOT NULL DEFAULT '0',
  `hash` int(10) unsigned NOT NULL DEFAULT '0',
  `is_read` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`),
  KEY `uid` (`touid`,`dateline`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_myop_userapp
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_myop_userapp`;

CREATE TABLE `ts_myop_userapp` (
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `appid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `appname` varchar(60) NOT NULL DEFAULT '',
  `privacy` tinyint(1) NOT NULL DEFAULT '0',
  `allowsidenav` tinyint(1) NOT NULL DEFAULT '0',
  `allowfeed` tinyint(1) NOT NULL DEFAULT '0',
  `allowprofilelink` tinyint(1) NOT NULL DEFAULT '0',
  `narrow` tinyint(1) NOT NULL DEFAULT '0',
  `menuorder` smallint(6) NOT NULL DEFAULT '0',
  `displayorder` smallint(6) NOT NULL DEFAULT '0',
  `ext` text,
  KEY `uid` (`uid`,`appid`),
  KEY `menuorder` (`uid`,`menuorder`),
  KEY `displayorder` (`uid`,`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_myop_userappfield
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_myop_userappfield`;

CREATE TABLE `ts_myop_userappfield` (
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `appid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `profilelink` text NOT NULL,
  `myml` text NOT NULL,
  KEY `uid` (`uid`,`appid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_myop_userlog
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_myop_userlog`;

CREATE TABLE `ts_myop_userlog` (
  `uid` int(11) NOT NULL DEFAULT '0',
  `action` varchar(255) NOT NULL,
  `type` tinyint(1) NOT NULL DEFAULT '0',
  `dateline` int(11) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_node
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_node`;

CREATE TABLE `ts_node` (
  `node_id` int(11) NOT NULL AUTO_INCREMENT,
  `app_name` varchar(255) NOT NULL,
  `app_alias` varchar(255) DEFAULT NULL,
  `mod_name` varchar(255) NOT NULL,
  `mod_alias` varchar(255) DEFAULT NULL,
  `act_name` varchar(255) NOT NULL,
  `act_alias` varchar(255) DEFAULT NULL,
  `parent_node_id` int(11) NOT NULL COMMENT '??action',
  `description` text,
  PRIMARY KEY (`node_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_node` DISABLE KEYS */;
INSERT INTO `ts_node` (`app_name`,`app_alias`,`mod_name`,`mod_alias`,`act_name`,`act_alias`,`parent_node_id`,`description`)
VALUES
	('admin','管理后台','*','全部','*','全部',0,'在“权限管理”中将本节点赋予某个用户组，它就能访问管理后台了');

/*!40000 ALTER TABLE `ts_node` ENABLE KEYS */;


# Dump of table ts_notify
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_notify`;

CREATE TABLE `ts_notify` (
  `notify_id` int(11) NOT NULL auto_increment,
  `from` int(11) NOT NULL,
  `receive` int(11) NOT NULL,
  `type` char(80) NOT NULL,
  `data` text NOT NULL,
  `is_read` tinyint(1) NOT NULL default '0',
  `ctime` int(11) NOT NULL,
  PRIMARY KEY  (`notify_id`),
  KEY `receive` (`receive`,`is_read`),
  KEY `ctime` (`ctime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_space
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_space`;

CREATE TABLE `ts_space` (
  `uid` int(11) unsigned NOT NULL DEFAULT '0',
  `hit` int(11) unsigned NOT NULL DEFAULT '0',
  `setting` text NOT NULL,
  `credit_score` int(11) unsigned NOT NULL DEFAULT '0',
  `credit_exp` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_system_data
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_system_data`;

CREATE TABLE `ts_system_data` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL DEFAULT '0',
  `list` char(30) DEFAULT 'default',
  `key` char(50) DEFAULT 'default',
  `value` text,
  `mtime` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `list` (`list`,`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

# Dump of table ts_tag
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_tag`;

CREATE TABLE `ts_tag` (
  `tag_id` int(11) NOT NULL AUTO_INCREMENT,
  `tag_name` varchar(120) NOT NULL,
  PRIMARY KEY (`tag_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_template
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_template`;

CREATE TABLE `ts_template` (
  `tpl_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `title` text,
  `body` text,
  `lang` varchar(255) NOT NULL DEFAULT 'zh',
  `type` varchar(255) DEFAULT NULL,
  `type2` varchar(255) DEFAULT NULL,
  `is_cache` tinyint(1) NOT NULL DEFAULT '1',
  `ctime` int(11) DEFAULT NULL,
  PRIMARY KEY (`tpl_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_template` DISABLE KEYS */;
INSERT INTO `ts_template` (`tpl_id`,`name`,`alias`,`title`,`body`,`lang`,`type`,`type2`,`is_cache`,`ctime`)
VALUES
	(1,'invite_register','邀请注册','{actor_name}邀请您加入{site_name}','亲爱的{email}您好，\r\n{actor}邀请您加入{site}','zh','invite','',1,1282554257);

/*!40000 ALTER TABLE `ts_template` ENABLE KEYS */;

# Dump of table ts_template_record
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_template_record`;

CREATE TABLE `ts_template_record` (
  `tpl_record_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `tpl_name` varchar(255) NOT NULL DEFAULT '',
  `tpl_alias` varchar(255) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `type2` varchar(255) DEFAULT NULL,
  `data` text,
  `ctime` int(11) DEFAULT NULL,
  PRIMARY KEY (`tpl_record_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user`;

CREATE TABLE `ts_user` (
  `uid` int(11) NOT NULL AUTO_INCREMENT,
  `email` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `uname` varchar(255) DEFAULT NULL,
  `sex` tinyint(1) NOT NULL DEFAULT '0',
  `province` mediumint(6) NOT NULL DEFAULT '0',
  `city` mediumint(6) NOT NULL DEFAULT '0',
  `location` varchar(255) DEFAULT NULL,
  `admin_level` varchar(255) DEFAULT '0',
  `commend` tinyint(1) DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `is_init` tinyint(1) NOT NULL,
  `is_synchronizing` tinyint(1) NOT NULL DEFAULT '0',
  `ctime` int(11) DEFAULT NULL,
  `identity` tinyint(1) NOT NULL DEFAULT '1',
  `score` int(11) NOT NULL DEFAULT '0',
  `myop_menu_num` int(2) NOT NULL DEFAULT '10',
  `api_key` varchar(255) DEFAULT NULL,
  `domain` char(80) NOT NULL,
  `face`  tinyint(1) NULL DEFAULT 0,
  PRIMARY KEY (`uid`),
  UNIQUE KEY `email` (`email`),
  KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_app
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_app`;

CREATE TABLE `ts_user_app` (
  `user_app_id` int(11) unsigned NOT NULL auto_increment,
  `app_id` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `display_order` int(5) NOT NULL default '0',
  `ctime` int(11) default NULL,
  PRIMARY KEY  (`user_app_id`),
  KEY `display_order` (`display_order`),
  KEY `app_id` (`app_id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_blacklist
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_blacklist`;

CREATE TABLE `ts_user_blacklist` (
  `uid` int(11) NOT NULL,
  `fid` int(11) NOT NULL,
  `ctime` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_count
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_count`;

CREATE TABLE `ts_user_count` (
  `uid` int(11) NOT NULL,
  `atme` mediumint(6) NOT NULL,
  `comment` mediumint(6) NOT NULL,
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_group
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_group`;

CREATE TABLE `ts_user_group` (
  `user_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `ctime` int(11) DEFAULT NULL,
  `icon` varchar(120) NOT NULL,
  PRIMARY KEY (`user_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_user_group` DISABLE KEYS */;
INSERT INTO `ts_user_group` (`user_group_id`,`title`,`ctime`,`icon`)
VALUES
	(1,'管理员',1291136345,'v_05.gif');

/*!40000 ALTER TABLE `ts_user_group` ENABLE KEYS */;

# Dump of table ts_user_group_link
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_group_link`;

CREATE TABLE `ts_user_group_link` (
  `user_gorup_link_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_group_id` int(11) NOT NULL,
  `user_group_title` varchar(255) DEFAULT NULL,
  `uid` int(11) NOT NULL,
  PRIMARY KEY  (`user_gorup_link_id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_group_popedom
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_group_popedom`;

CREATE TABLE `ts_user_group_popedom` (
  `user_group_popedom_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_group_id` int(11) NOT NULL,
  `node_id` int(11) NOT NULL,
  PRIMARY KEY (`user_group_popedom_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_user_group_popedom` DISABLE KEYS */;
INSERT INTO `ts_user_group_popedom` (`user_group_popedom_id`,`user_group_id`,`node_id`)
VALUES
	(1,1,1);

/*!40000 ALTER TABLE `ts_user_group_popedom` ENABLE KEYS */;

# Dump of table ts_user_online
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_online`;

CREATE TABLE `ts_user_online` (
  `uid` int(11) NOT NULL,
  `ctime` int(11) NOT NULL,
  UNIQUE KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_privacy
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_privacy`;

CREATE TABLE `ts_user_privacy` (
  `uid` int(11) NOT NULL,
  `key` varchar(120) NOT NULL,
  `value` varchar(120) NOT NULL,
  UNIQUE KEY `key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_profile
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_profile`;

CREATE TABLE `ts_user_profile` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `module` varchar(150) NOT NULL,
  `data` longtext,
  `type` varchar(60) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_user_set
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_set`;

CREATE TABLE `ts_user_set` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fieldkey` varchar(120) NOT NULL,
  `fieldname` varchar(120) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `module` varchar(60) NOT NULL,
  `showspace` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_user_set` DISABLE KEYS */;
INSERT INTO `ts_user_set` (`id`,`fieldkey`,`fieldname`,`status`,`module`,`showspace`)
VALUES
	(3,'name','名字',1,'intro',1),
	(4,'summary','我的简介',1,'intro',0),
	(5,'nearestwish','最近心愿',1,'intro',0),
	(6,'motto','座右铭',1,'intro',0),
	(7,'idol','偶像',1,'intro',0),
	(8,'favbook','喜欢的书',1,'intro',0),
	(9,'interest','兴趣爱好',1,'intro',0),
	(10,'address','地址',1,'contact',0),
	(11,'postcode','邮编',1,'contact',0),
	(12,'telphone','电话',1,'contact',0),
	(13,'mobile','手机',1,'contact',0),
	(14,'qq','QQ',1,'contact',0),
	(15,'msn','MSN',1,'contact',0),
	(16,'blood','血型',1,'intro',0);

/*!40000 ALTER TABLE `ts_user_set` ENABLE KEYS */;

# Dump of table ts_user_tag
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_user_tag`;

CREATE TABLE `ts_user_tag` (
  `user_tag_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `tag_id` int(11) NOT NULL,
  PRIMARY KEY (`user_tag_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_validation
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_validation`;

CREATE TABLE `ts_validation` (
  `validation_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(255) DEFAULT NULL,
  `from_uid` int(11) NOT NULL DEFAULT '0',
  `to_user` varchar(255) NOT NULL DEFAULT '0',
  `data` text,
  `code` varchar(120) NOT NULL DEFAULT '0',
  `target_url` varchar(255) DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL DEFAULT '1',
  `ctime` int(11) DEFAULT NULL,
  PRIMARY KEY (`validation_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_weibo
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo`;

CREATE TABLE `ts_weibo` (
  `weibo_id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `content` text NOT NULL,
  `ctime` int(11) NOT NULL,
  `from` tinyint(1) NOT NULL,
  `comment` mediumint(8) NOT NULL,
  `transpond_id` int(11) NOT NULL default '0',
  `transpond` mediumint(8) NOT NULL,
  `type` varchar(255) default '0',
  `type_data` text,
  `from_data` text,
  `isdel` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`weibo_id`),
  KEY `type` (`uid`,`type`),
  KEY `transpond` (`uid`,`transpond_id`),
  KEY `ctime` (`ctime`),
  KEY `uid_2` (`uid`,`isdel`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_weibo_atme
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo_atme`;

CREATE TABLE `ts_weibo_atme` (
  `uid` int(11) NOT NULL,
  `weibo_id` int(11) NOT NULL,
  UNIQUE KEY `uid` (`uid`,`weibo_id`),
  KEY `weibo_id` (`weibo_id`,`uid`),
  KEY `uid_2` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


# Dump of table ts_weibo_comment
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo_comment`;

CREATE TABLE `ts_weibo_comment` (
  `comment_id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `reply_comment_id` int(11) NOT NULL,
  `reply_uid` int(11) NOT NULL,
  `weibo_id` int(11) NOT NULL,
  `content` text NOT NULL,
  `ctime` int(11) NOT NULL,
  `isdel` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`comment_id`),
  KEY `weibo_id` (`weibo_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_weibo_favorite
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo_favorite`;

CREATE TABLE `ts_weibo_favorite` (
  `uid` int(11) NOT NULL,
  `weibo_id` int(11) NOT NULL,
  PRIMARY KEY (`uid`,`weibo_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_weibo_follow
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo_follow`;

CREATE TABLE `ts_weibo_follow` (
  `follow_id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `fid` int(11) NOT NULL,
  `type` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`follow_id`),
  KEY `fid` (`fid`,`type`),
  KEY `uid` (`uid`,`type`),
  KEY `uid_fid` (`uid`,`fid`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table ts_weibo_plugin
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo_plugin`;

CREATE TABLE `ts_weibo_plugin` (
  `plugin_id` int(11) NOT NULL AUTO_INCREMENT,
  `plugin_name` varchar(120) NOT NULL,
  `icon_pic` varchar(120) NOT NULL,
  `plugin_path` varchar(255) NOT NULL,
  PRIMARY KEY (`plugin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `ts_weibo_plugin` DISABLE KEYS */;
INSERT INTO `ts_weibo_plugin` (`plugin_id`,`plugin_name`,`icon_pic`,`plugin_path`)
VALUES
	(1,'图片','','image'),
	(3,'视频','','video'),
	(4,'音乐','','music');

/*!40000 ALTER TABLE `ts_weibo_plugin` ENABLE KEYS */;

# Dump of table ts_weibo_topic
# ------------------------------------------------------------;

DROP TABLE IF EXISTS `ts_weibo_topic`;

CREATE TABLE `ts_weibo_topic` (
  `topic_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(150) NOT NULL,
  `count` int(11) NOT NULL,
  `ctime` int(11) NOT NULL,
  `status`  tinyint(1) NOT NULL DEFAULT 0,
  `lock`  tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY  (`topic_id`),
  KEY `count` (`count`),
  KEY `name` (`name`,`count`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

# 新增ts_credit_setting, ts_credit_type, ts_credit_user表
DROP TABLE IF EXISTS `ts_credit_setting`;

CREATE TABLE `ts_credit_setting` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `type` varchar(30) NOT NULL default 'user',
  `info` text NOT NULL,
  `score` int(11) NOT NULL default '0',
  `experience` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `ts_credit_setting` (`id`,`name`,`alias`,`type`,`info`,`score`,`experience`)
VALUES
    (34,'add_blog','发表博客','blog','{action}{sign}了{score}{typecn}',5,5),
    (37,'invite_friend','邀请好友','register','{action}{sign}了{score}{typecn}',10,10),
    (39,'add_weibo','发布微博','weibo','{action}{sign}了{score}{typecn}',1,2),
    (40,'user_login','用户登录','user','{action}{sign}了{score}{typecn}',0,1),
    (42,'space_visited','空间被访问','user','{action}{sign}了{score}{typecn}',1,1),
    (45,'add_vote','发起投票','vote','{action}{sign}了{score}{typecn}',20,20),
    (46,'join_vote','参与投票','vote','{action}{sign}了{score}{typecn}',1,5),
    (47,'joined_vote','投票被参与','vote','{action}{sign}了{score}{typecn}',1,1),
    (92,'init_default','注册积分','register','{action}{sign}了{score}{typecn}',200,0),
    (56,'add_album','创建相册','photo','{action}{sign}了{score}{typecn}',10,10),
    (59,'add_comment','评论别人','comment','{action}{sign}了{score}{typecn}',1,1),
    (60,'reply_comment','回复别人的评论','comment','{action}{sign}了{score}{typecn}',1,1),
    (61,'replied_comment','评论被回复','comment','{action}{sign}了{score}{typecn}',2,2),
    (63,'reply_weibo','回复微博','weibo','{action}{sign}了{score}{typecn}',1,1),
    (64,'replied_weibo','微博被回复','weibo','{action}{sign}了{score}{typecn}',1,1),
    (81,'is_commented','被别人评论','comment','{action}{sign}了{score}{typecn}',1,2),
    (82,'add_photo','上传图片','photo','{action}{sign}了{score}{typecn}',2,2),
    (83,'share_to_weibo','分享到微博','weibo','{action}{sign}了{score}{typecn}',3,3),
    (84,'delete_blog','删除博客','blog','{action}{sign}了{score}{typecn}',-5,-5),
    (85,'delete_album','删除相册','photo','{action}{sign}了{score}{typecn}',-10,-10),
    (86,'delete_photo','删除图片','photo','{action}{sign}了{score}{typecn}',-2,-2),
    (87,'delete_vote','删除投票','vote','{action}{sign}了{score}{typecn}',-20,-20),
    (88,'delete_comment','删除评论','comment','{action}{sign}了{score}{typecn}',-2,-2),
    (89,'delete_weibo','删除微博','weibo','{action}{sign}了{score}{typecn}',-2,-2),
    (90,'forward_weibo','转发微博','weibo','{action}{sign}了{score}{typecn}',1,1),
    (91,'forwarded_weibo','微博被转发','weibo','{action}{sign}了{score}{typecn}',1,1),
    (93,'delete_weibo_comment','删除微博评论','weibo','{action}{sign}了{score}{typecn}',-1,-1);


DROP TABLE IF EXISTS `ts_credit_type`;

CREATE TABLE `ts_credit_type` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `alias` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `ts_credit_type` (`name`,`alias`)
VALUES
    ('score','积分'),
    ('experience','经验');

DROP TABLE IF EXISTS `ts_credit_user`;

CREATE TABLE `ts_credit_user` (
  `id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `score` int(11) NOT NULL,
  `experience` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

##################################################################################################################
# 以下为 ThinkSNS 2.1 beta Build 10470 新增的数据表
# ts_denounce, ts_admin_log, ts_weibo_follow_group, ts_weibo_follow_group_link, ts_weibo_star, ts_weibo_star_group

DROP TABLE IF EXISTS `ts_denounce`;

CREATE TABLE `ts_denounce` (
  `id` int(11) NOT NULL auto_increment COMMENT '主键ID',
  `from` varchar(255) NOT NULL COMMENT '目前存入各个应用的名称，比如blog,weibo，说明举报的是不同应用下的内容',
  `aid` int(11) NOT NULL COMMENT '记录内容表的主键ID',
  `state` tinyint(4) NOT NULL COMMENT '记录状态，0，默认，表示刚举报；1，表示已删除；2，表示已经通过可以正常显示；',
  `uid` int(11) NOT NULL COMMENT '记录举报人的UID',
  `fuid` int(11) NOT NULL COMMENT '记录被举报人UID',
  `reason` text NOT NULL COMMENT '举报理由',
  `content` varchar(255) NOT NULL,
  `ctime` int(11) NOT NULL COMMENT '记录举报的时间',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#------------------------------------#

DROP TABLE IF EXISTS `ts_admin_log`;

CREATE TABLE `ts_admin_log` (
  `id` int(11) NOT NULL auto_increment COMMENT '主键ID',
  `uid` int(11) NOT NULL COMMENT '操作人UID',
  `type` tinyint(4) NOT NULL,
  `data` text NOT NULL,
  `ctime` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#------------------------------------#

DROP TABLE IF EXISTS `ts_weibo_follow_group`;

CREATE TABLE `ts_weibo_follow_group` (
  `follow_group_id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `ctime` int(11) default NULL,
  PRIMARY KEY  (`follow_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#------------------------------------#

DROP TABLE IF EXISTS `ts_weibo_follow_group_link`;

CREATE TABLE `ts_weibo_follow_group_link` (
  `follow_group_link_id` int(11) NOT NULL auto_increment,
  `follow_group_id` int(11) NOT NULL,
  `follow_id` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  PRIMARY KEY  (`follow_group_link_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#------------------------------------#

DROP TABLE IF EXISTS `ts_weibo_star`;

CREATE TABLE `ts_weibo_star` (
  `star_id` int(11) NOT NULL auto_increment,
  `star_group_id` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `ctime` int(11) default NULL,
  PRIMARY KEY  (`star_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#------------------------------------#

DROP TABLE IF EXISTS `ts_weibo_star_group`;

CREATE TABLE `ts_weibo_star_group` (
  `star_group_id` int(11) NOT NULL auto_increment,
  `top_group_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL,
  `display_order` int(11) NOT NULL default '0',
  `ctime` int(11) default NULL,
  PRIMARY KEY  (`star_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

##################################################################################################################
# 以下为 ThinkSNS 2.1 Build 10920 新增的数据表
# 
DROP TABLE IF EXISTS `ts_ucenter_user_link`;

CREATE TABLE `ts_ucenter_user_link` (
  `uid` int(11) NOT NULL,
  `uc_uid` mediumint(8) NOT NULL,
  `uc_username` char(15) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

##################################################################################################################
# 以下为 ThinkSNS 2.2 新增的数据表
# ts_invite_record
#

DROP TABLE IF EXISTS `ts_invite_record`;

CREATE TABLE IF NOT EXISTS `ts_invite_record` (
  `invite_record_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL,
  `fid` int(11) unsigned NOT NULL,
  `ctime` int(11) unsigned NOT NULL,
  `valid`  tinyint(1) NULL DEFAULT 1,
  PRIMARY KEY (`invite_record_id`),
  UNIQUE KEY `uid` (`uid`,`fid`),
  KEY `ctime` (`ctime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;

/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;

##################################################################################################################
# 以下为 ThinkSNS 2.3 新增的数据表
# ts_weibo_topics
#

DROP TABLE IF EXISTS `ts_weibo_topics`;

CREATE TABLE IF NOT EXISTS `ts_weibo_topics` (
  `topics_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `topic_id` int(11) unsigned NOT NULL,
  `domain` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  `pic` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `link` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `note` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `content` text COLLATE utf8_unicode_ci,
  `recommend` enum('1','0') COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `ctime` int(11) DEFAULT NULL,
  `isdel` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`topics_id`),
  UNIQUE KEY `page` (`domain`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ;

##################################################################################################################
# ThinkSNS 2.5 新增的表
# ts_addons
#

DROP TABLE IF EXISTS `ts_addons`;

CREATE TABLE IF NOT EXISTS `ts_addons` (
  `addonId` int(4) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `pluginName` varchar(255) NOT NULL DEFAULT '',
  `author` varchar(255) NOT NULL DEFAULT '',
  `info` tinytext,
  `version` varchar(50) DEFAULT NULL,
  `status` enum('0','1') NOT NULL DEFAULT '1',
  `lastupdate` varchar(255) DEFAULT '',
  `site` varchar(255) DEFAULT NULL,
  `tsVersion` varchar(11) DEFAULT '2.5',
  PRIMARY KEY (`addonId`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ;


DROP TABLE IF EXISTS `ts_weibo_attach`;

CREATE TABLE IF NOT EXISTS `ts_weibo_attach` (
  `weibo_id` int(11) NOT NULL,
  `attach_id` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `weibo_type` tinyint(3) NOT NULL,
  `mtime` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  KEY `user_attach` (`uid`,`attach_id`,`weibo_type`),
  KEY `weibo_index` (`weibo_id`,`weibo_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微博附件表';


DROP TABLE IF EXISTS `ts_user_data`;

CREATE TABLE IF NOT EXISTS `ts_user_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `key` varchar(50) NOT NULL,
  `value` text,
  `mtime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user-key` (`uid`,`key`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `ts_message_content`;

CREATE TABLE `ts_message_content` (
  `message_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `list_id` int(11) unsigned NOT NULL,
  `from_uid` int(11) unsigned NOT NULL,
  `content` text,
  `is_del` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `mtime` int(11) unsigned NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `list_id` (`list_id`,`is_del`,`mtime`),
  KEY `list_id_2` (`list_id`,`mtime`)
) ENGINE=MyISAM AUTO_INCREMENT=84 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `ts_message_list`;

CREATE TABLE `ts_message_list` (
  `list_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `from_uid` int(11) unsigned NOT NULL,
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) DEFAULT NULL,
  `member_num` smallint(5) unsigned NOT NULL DEFAULT '0',
  `min_max` varchar(17) DEFAULT NULL,
  `mtime` int(11) unsigned NOT NULL,
  `last_message` text NOT NULL,
  PRIMARY KEY (`list_id`),
  KEY `type` (`type`),
  KEY `min_max` (`min_max`),
  KEY `from_uid` (`from_uid`,`mtime`)
) ENGINE=MyISAM AUTO_INCREMENT=49 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `ts_message_member`;

CREATE TABLE `ts_message_member` (
  `list_id` int(11) unsigned NOT NULL,
  `member_uid` int(11) unsigned NOT NULL,
  `new` smallint(8) unsigned NOT NULL DEFAULT '0',
  `message_num` int(10) unsigned NOT NULL DEFAULT '1',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0',
  `list_ctime` int(11) unsigned NOT NULL,
  PRIMARY KEY (`list_id`,`member_uid`),
  KEY `new` (`new`),
  KEY `ctime` (`ctime`),
  KEY `list_ctime` (`list_ctime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `ts_weibo_topic_link`;

CREATE TABLE `ts_weibo_topic_link` (
  `weibo_topic_id` int(11) NOT NULL auto_increment,
  `weibo_id` int(11) NOT NULL,
  `topic_id` int(11) NOT NULL,
  `type` varchar(255) NOT NULL default '0',
  `transpond_id` int(11) NOT NULL default 0,
  PRIMARY KEY  (`weibo_topic_id`),
  KEY `topic_type` (`topic_id`,`type`),
  KEY `topic_transpond` (`topic_id`,`transpond_id`),
  KEY `weibo` (`weibo_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


##################################################################################################################
# ThinkSNS 2.5 sp2新增的表
# ts_user_verified
#

DROP TABLE IF EXISTS `ts_user_verified`;

CREATE TABLE `ts_user_verified` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL,
  `realname` varchar(50) COLLATE utf8_unicode_ci DEFAULT NULL,
  `phone` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
  `reason` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `info` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `verified` enum('0','1') COLLATE utf8_unicode_ci NOT NULL DEFAULT '0',
  `attachment` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ts_user_changestyle`;

CREATE TABLE `ts_user_changestyle` (
  `uid` int(11) unsigned NOT NULL,
  `classname` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `diybg` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `diybgcolor` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  UNIQUE KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `ts_url`;

CREATE TABLE `ts_url` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `url` tinytext NOT NULL COMMENT '原网址',
  `hash` varchar(32) DEFAULT NULL COMMENT '长网址的hash,便于查询已存在地址',
  `hits` int(11) NOT NULL COMMENT '点击量',
  `status` tinyint(1) NOT NULL COMMENT '=1可用,=0不可用',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

##################################################################################################################
# ThinkSNS 2.8 新增的表
# ts_webpage
#

DROP TABLE IF EXISTS `ts_webpage`;

CREATE TABLE `ts_webpage` (
`webpage_id`  int(11) NOT NULL AUTO_INCREMENT ,
`url`  text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
`hash`  char(32) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
`title`  varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
`comment_count`  int(11) NOT NULL DEFAULT 0 ,
PRIMARY KEY (`webpage_id`),
UNIQUE INDEX `hash` USING BTREE (`hash`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARACTER SET=utf8;


DROP TABLE IF EXISTS `ts_user_change_style`;

CREATE TABLE IF NOT EXISTS `ts_user_change_style` (
  `uid` int(11) unsigned NOT NULL,
  `classname` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `background` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  UNIQUE KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

##################################################################################################################
# 初始化数据

INSERT INTO `ts_addons` (`addonId`, `name`, `pluginName`, `author`, `info`, `version`, `status`, `lastupdate`, `site`, `tsVersion`) VALUES
(1, 'SpaceFollow', '空间粉丝和关注列表', 'SamPeng', '显示空间粉丝和关注列表，提升互动', '1.0', '1', '', 'http://weibo.com/sampeng', '2.5'),
(2, 'ShortUrl', '短网址', '海虾', '短网址插件', '1.0', '1', '', 'http://www.thinksns.com', '2.5'),
(3, 'SquareAppShow', '广场应用展示', '陈伟川', '广场应用展示，综合站点信息', '1.0', '1', '', 'http://weibo.com/cchhuuaann', '2.5'),
(4, 'WeiboType', '微博类型', '冷浩然,杨德升,陈伟川,彭灵俊', '控制发布微博的类型插件', '1.0', '1', '', 't.thinksns.com', '2.5'),
(5, 'SpaceAppShow', '个人主页应用展示', '陈伟川', '个人主页应用展示', '1.0', '1', '', 'http://weibo.com/cchhuuaann', '2.5'),
(6, 'UserSpaceCard', '小名片', '海虾', '用户信息小名片', '1.0', '1', '', 'http://www.thinksns.com', '2.5'),
(7, 'UserVerified', '用户认证', '陈伟川', '认证身份', '1.0', '1', '', 'http://weibo.com/cchhuuaann', '2.5'),
(8, 'RelatedUser', '可能认识的人', '海虾', '可能认识的人', '1.0', '1', '', 'http://www.thinksns.com', '2.8'),
(9, 'SpaceStyle', '空间换肤-官方优化版', '智士软件', '用户自定义风格官方优化版', '2.0', '1', '', 'http://www.thinksns.com', '2.5'),
(10, 'Login', '微博同步', '冷浩然,杨德升,陈伟川', '同步登录其他微博系统', '2.0', '1', '', 't.thinksns.com', '2.5');

INSERT INTO `ts_system_data` (`id`, `uid`, `list`, `key`, `value`, `mtime`) VALUES
(49, 0, 'siteopt', 'site_name', 's:8:"ThinkSNS";', '2012-07-11 10:27:23'),
(68, 0, 'siteopt', 'site_slogan', 'N;', '2012-07-11 10:27:23'),
(54, 0, 'siteopt', 'site_closed', 'i:0;', '2012-07-11 10:27:23'),
(63, 0, 'siteopt', 'site_verify', 'a:2:{i:0;s:8:"register";i:1;s:5:"login";}', '2012-07-11 10:27:23'),
(59, 0, 'siteopt', 'site_user_domain_on', 's:1:"1";', '2012-07-11 10:27:23'),
(6, 0, 'siteopt', 'site_system_version', 's:20:"ThinkSNS V2.8 stable";', '2012-07-12 10:00:00'),
(7, 0, 'siteopt', 'site_system_version_number', 's:5:"36263";', '2012-07-12 10:00:00'),
(62, 0, 'siteopt', 'expression', 's:8:"miniblog";', '2012-07-11 10:27:23'),
(69, 0, 'register', 'register_type', 's:6:"invite";', '2012-07-11 10:27:42'),
(70, 0, 'register', 'register_email_activate', 's:1:"0";', '2012-07-11 10:27:42'),
(71, 0, 'register', 'register_auto_friend', 's:1:"1";', '2012-07-11 10:27:42'),
(12, 0, 'register', 'register_realname_check', 's:1:"0";', '2010-11-25 09:33:01'),
(13, 0, 'register', 'register_lastname_single', 's:3582:"艾,安,昂,敖,奥,巴,霸,白,柏,拜,班,包,保,葆,豹,鲍,暴,卑,贲,毕,闭,秘,边,鞭,彪,别,宾,邴,秉,薄,卜,布,部,才,蔡,仓,苍,操,曹,策,岑,柴,镡,昌,苌,常,昶,畅,唱,晁,巢,朝,车,陈,谌,成,承,晟,乘,程,池,迟,充,种,崇,丑,侴,初,储,楚,禇,揣,啜,春,椿,慈,次,从,丛,爨,崔,萃,寸,达,笪,大,代,戴,丹,但,啖,党,刀,德,邓,狄,翟,邸,底,弟,典,刁,丁,定,东,冬,董,豆,窦,都,堵,杜,度,端,段,敦,顿,多,朵,颚,恩,法,氾,樊,范,方,芳,防,房,费,丰,风,封,酆,冯,逢,凤,奉,俸,伏,扶,苻,服,符,福,付,傅,富,改,盖,干,甘,淦,冮,刚,皋,高,杲,郜,戈,革,合,格,盖,葛,庚,赓,耿,弓,公,宫,龚,巩,贡,勾,缑,苟,勾,辜,古,谷,固,顾,关,官,筦,管,观,贯,冠,光,广,归,妫,邽,炅,炔,贵,桂,滚,过,呙,郭,国,虢,果,哈,海,罕,撖,杭,郝,合,何,和,亻各,贺,赫,黑,亨,恒,衡,弘,闳,宏,鸿,侯,后,郈,厚,呼,轷,狐,胡,壶,虎,户,扈,花,华,滑,华,怀,槐,还,环,郇,桓,宦,皇,黄,回,惠,浑,火,霍,姬,嵇,稽,及,吉,汲,姞,戢,集,藉,籍,纪,计,季,暨,冀,加,家,嘉,郏,甲,贾,坚,菅,检,简,翦,蹇,见,监,江,将,姜,蒋,降,焦,矫,皎,敫,曒,教,接,揭,节,介,金,晋,烬,京,经,荆,井,景,敬,靖,静,酒,局,倶,琚,鞠,菊,巨,剧,隽,圈,角,开,凯,阚,康,亢,伉,柯,可,坑,孔,寇,库,蒯,郐,宽,匡,邝,旷,况,奎,隗,夔,腊,来,赖,兰,蓝,郎,劳,老,乐,雷,冷,离,黎,李,里,力,历,厉,立,励,利,郦,栗,连,廉,练,良,梁,聊,廖,列,林,临,吝,蔺,令,泠,凌,刘,留,柳,龙,隆,娄,楼,卢,庐,鲁,陆,逯,禄,路,闾,吕,律,栾,论,论,罗,洛,骆,雒,麻,马,买,麦,满,莽,毛,茆,茅,冒,枚,梅,门,蒙,孟,弥,祢,糜,米,芈,弭,宓,密,苗,缪,闵,敏,名,万,莫,墨,默,牟,母,木,沐,睦,慕,穆,那,纳,乃,佴,南,铙,倪,年,粘,念,乜,聂,宁,牛,钮,农,侬,区,欧,潘,盘,泮,庞,裴,彭,邳,皮,朴,品,平,繁,蒲,濮,浦,普,溥,柒,戚,漆,亓,齐,祁,歧,綦,乞,杞,启,千,钱,潜,强,乔,桥,谯,且,郄,钦,秦,琴,覃,勤,青,卿,清,庆,丘,邱,秋,仇,求,裘,曲,屈,麴,渠,璩,瞿,蘧,权,全,泉,阙,冉,饶,壬,任,戎,荣,容,茹,汝,阮,软,芮,瑞,洒,撒,萨,伞,桑,沙,山,闪,陕,单,善,商,赏,尚,少,召,邵,折,佘,厍,舍,申,莘,神,沈,生,绳,盛,师,施,石,时,史,士,世,是,奭,首,寿,殳,舒,疏,束,树,耍,帅,双,水,睡,顺,司,思,死,斯,四,佀,姒,松,宋,苏,宿,粟,眭,睢,隋,随,穗,孙,所,索,塔,台,邰,台,太,泰,谈,覃,谭,澹,檀,镡,汤,唐,棠,陶,腾,提,遆,题,帖,铁,通,仝,同,佟,彤,童,钭,徒,涂,屠,土,脱,完,宛,晚,万,汪,王,望,危,韦,维,蒍,隗,位,尉,温,文,闻,问,翁,瓮,邬,巫,毋,吾,吴,伍,仵,武,务,西,析,郗,息,奚,锡,习,席,袭,隰,舄,夏,先,鲜,咸,冼,洗,羡,线,相,香,襄,祥,向,相,项,肖,萧,孝,谢,渫,辛,忻,新,信,兴,星,刑,邢,行,幸,熊,修,须,顼,徐,许,旭,续,轩,禤,旋,薛,穴,雪,寻,郇,荀,押,牙,轧,鄢,燕,延,严,言,阎,颜,晏,扬,羊,阳,杨,仰,幺,要,尧,姚,铫,药,冶,业,叶,伊,衣,依,仪,宜,乙,蚁,扆,弋,义,亦,易,弈,益,裔,翼,阴,殷,银,尹,印,应,英,营,赢,灜,雍,勇,涌,幽,尤,由,游,於,欲,余,鱼,俞,馀,宇,禹,庾,玉,郁,遇,喻,裕,毓,渊,元,袁,原,圆,源,员,苑,院,乐,岳,悦,越,云,妘,郧,运,员,郓,恽,韵,载,昝,臧,迮,笮,曾,增,查,乍,翟,呰,祭,占,詹,瞻,展,战,湛,张,章,彰,仉,掌,招,召,兆,赵,肇,真,甄,镇,正,郑,政,支,执,直,植,志,郅,智,终,钟,衷,种,仲,周,朱,邾,诸,竹,竺,主,祝,专,庄,卓,禚,资,訾,子,紫,宗,邹,驺,俎,祖,左,韩";', '2010-07-29 08:43:04'),
(14, 0, 'register', 'register_lastname_double', 's:3060:"安陵,安平,安期,安阳,白马,百里,柏侯,鲍俎,北宫,北郭,北门,北山,北唐,奔水,逼阳,宾牟,薄奚薄野,曹牟,曹丘,常涛,长鱼,车非,成功,成阳,乘马,叱卢,丑门,樗里,穿封,淳子,答禄,达勃,达步,达奚,淡台,邓陵,第五,地连,地伦,东方,东里,东南,东宫,东门东乡,东丹,东郭,东陵,东关,东闾,东阳,东野,东莱,豆卢,斗于,都尉,独孤端木,段干,多子,尔朱,方雷丰将,封人,封父,夫蒙,夫馀,浮丘,傅余,干已,高车,高陵,高堂,高阳,高辛,皋落,哥舒,盖楼,庚桑,梗阳,宫孙,公羊,公良,公孙,公罔,公西,公冶,公敛,公梁,公输,公上,公山,公户,公玉,公仪,公仲公坚,公伯,公祖,公乘,公晰,公族,姑布,古口,古龙,古孙,谷梁,谷浑,瓜田,关龙,鲑阳,归海,函治,韩馀,罕井,浩生,浩星,纥骨,纥奚纥于,贺拨,贺兰,贺楼,赫连,黑齿,黑肱,侯冈,呼延,壶丘,呼衍,斛律,胡非,胡母,胡毋,皇甫,皇父,兀官吉白,即墨,季瓜,季连,季孙,茄众,蒋丘,金齿,晋楚,京城,泾阳,九百,九方,睢鸠,沮渠,巨母,勘阻,渴侯,渴单,可汗,空桐,空相,昆吾,老阳,乐羊,荔菲,栎阳,梁丘,梁由,梁馀,梁垣,陵阳伶舟,冷沦,令狐,刘王,柳下,龙丘,卢妃,卢蒲,鲁步,陆费,角里,闾丘,马矢,麦丘,茅夷,弥牟,密革,密茅,墨夷,墨台,万俊,昌顿,慕容,木门,木易,南宫,南郭,南门,南荣,欧侯,欧阳,逄门,盆成,彭祖,平陵,平宁,破丑,仆固,濮阳,漆雕,奇介,綦母,綦毋,綦连,祁连,乞伏,绮里,千代,千乘,勤宿,青阳,丘丽,丘陵,屈侯,屈突,屈男,屈卢,屈同,屈门,屈引,壤四,扰龙,容成,汝嫣,萨孤,三饭,三闾,三州,桑丘,商瞿,上官,尚方,少师,少施,少室,少叔,少正,社南社北,申屠,申徒,沈犹,胜屠,石作石牛,侍其,士季,士弱,士孙,士贞,叔孙,叔先,叔促,水丘,司城,司空,司寇,司鸿,司马,司徒,司士,似和,素和,夙沙,孙阳,索阳,索卢,沓卢,太史,太叔,太阳,澹台,唐山,堂溪,陶丘,同蹄,统奚,秃发,涂钦,吐火,吐贺,吐万,吐罗,吐门,吐难,吐缶,吐浑吐奚,吐和,屯浑,脱脱,拓拨,完颜,王孙,王官,王人,微生,尾勺,温孤,温稽,闻人,屋户,巫马,吾丘,无庸,无钩,五鹿,息夫,西陵,西乞,西钥,西乡,西门,西周,西郭,西方,西野,西宫,戏阳,瑕吕,霞露,夏侯,鲜虞,鲜于,鲜阳,咸丘,相里,解枇,谢丘,新垣,辛垣,信都,信平,修鱼,徐吾,宣于,轩辕,轩丘,阏氏,延陵,罔法,铅陵,羊角,耶律,叶阳,伊祁,伊耆,猗卢,义渠,邑由,因孙,银齿,尹文,雍门,游水,由吾,右师,宥连,於陵,虞丘,盂丘,宇文,尉迟,乐羊,乐正,运奄,运期,宰父,辗迟,湛卢,章仇,仉督,长孙,长儿,真鄂,正令,执头,中央,中长,中行,中野,中英,中梁,中垒,钟离,钟吾,终黎,终葵,仲孙,仲长,周阳,周氏,周生,朱阳,诸葛,主父,颛孙,颛顼,訾辱,淄丘,子言,子人,子服子家,子桑,子叔,子车,子阳,宗伯,宗正,宗政,尊卢,昨和,左人,左丘,左师,左行,刘文,额尔,达力,蔡斯,浩赏,斛斯,夹谷,揭阳,万俟,淳于,单于,徐离";', '2010-07-29 08:43:04'),
(15, 0, 'register', '__hash__', 's:32:"f81cb2f2175eaa0a59d1a48d2cd6dadb";', '2010-12-06 04:08:56'),
(16, 0, 'register', 'register_lastname', 's:6643:"艾,安,昂,敖,奥,巴,霸,白,柏,拜,班,包,保,葆,豹,鲍,暴,卑,贲,毕,闭,秘,边,鞭,彪,别,宾,邴,秉,薄,卜,布,部,才,蔡,仓,苍,操,曹,策,岑,柴,镡,昌,苌,常,昶,畅,唱,晁,巢,朝,车,陈,谌,成,承,晟,乘,程,池,迟,充,种,崇,丑,侴,初,储,楚,禇,揣,啜,春,椿,慈,次,从,丛,爨,崔,萃,寸,达,笪,大,代,戴,丹,但,啖,党,刀,德,邓,狄,翟,邸,底,弟,典,刁,丁,定,东,冬,董,豆,窦,都,堵,杜,度,端,段,敦,顿,多,朵,颚,恩,法,氾,樊,范,方,芳,防,房,费,丰,风,封,酆,冯,逢,凤,奉,俸,伏,扶,苻,服,符,福,付,傅,富,改,盖,干,甘,淦,冮,刚,皋,高,杲,郜,戈,革,合,格,盖,葛,庚,赓,耿,弓,公,宫,龚,巩,贡,勾,缑,苟,勾,辜,古,谷,固,顾,关,官,筦,管,观,贯,冠,光,广,归,妫,邽,炅,炔,贵,桂,滚,过,呙,郭,国,虢,果,哈,海,罕,撖,杭,郝,合,何,和,亻各,贺,赫,黑,亨,恒,衡,弘,闳,宏,鸿,侯,后,郈,厚,呼,轷,狐,胡,壶,虎,户,扈,花,华,滑,华,怀,槐,还,环,郇,桓,宦,皇,黄,回,惠,浑,火,霍,姬,嵇,稽,及,吉,汲,姞,戢,集,藉,籍,纪,计,季,暨,冀,加,家,嘉,郏,甲,贾,坚,菅,检,简,翦,蹇,见,监,江,将,姜,蒋,降,焦,矫,皎,敫,曒,教,接,揭,节,介,金,晋,烬,京,经,荆,井,景,敬,靖,静,酒,局,倶,琚,鞠,菊,巨,剧,隽,圈,角,开,凯,阚,康,亢,伉,柯,可,坑,孔,寇,库,蒯,郐,宽,匡,邝,旷,况,奎,隗,夔,腊,来,赖,兰,蓝,郎,劳,老,乐,雷,冷,离,黎,李,里,力,历,厉,立,励,利,郦,栗,连,廉,练,良,梁,聊,廖,列,林,临,吝,蔺,令,泠,凌,刘,留,柳,龙,隆,娄,楼,卢,庐,鲁,陆,逯,禄,路,闾,吕,律,栾,论,论,罗,洛,骆,雒,麻,马,买,麦,满,莽,毛,茆,茅,冒,枚,梅,门,蒙,孟,弥,祢,糜,米,芈,弭,宓,密,苗,缪,闵,敏,名,万,莫,墨,默,牟,母,木,沐,睦,慕,穆,那,纳,乃,佴,南,铙,倪,年,粘,念,乜,聂,宁,牛,钮,农,侬,区,欧,潘,盘,泮,庞,裴,彭,邳,皮,朴,品,平,繁,蒲,濮,浦,普,溥,柒,戚,漆,亓,齐,祁,歧,綦,乞,杞,启,千,钱,潜,强,乔,桥,谯,且,郄,钦,秦,琴,覃,勤,青,卿,清,庆,丘,邱,秋,仇,求,裘,曲,屈,麴,渠,璩,瞿,蘧,权,全,泉,阙,冉,饶,壬,任,戎,荣,容,茹,汝,阮,软,芮,瑞,洒,撒,萨,伞,桑,沙,山,闪,陕,单,善,商,赏,尚,少,召,邵,折,佘,厍,舍,申,莘,神,沈,生,绳,盛,师,施,石,时,史,士,世,是,奭,首,寿,殳,舒,疏,束,树,耍,帅,双,水,睡,顺,司,思,死,斯,四,佀,姒,松,宋,苏,宿,粟,眭,睢,隋,随,穗,孙,所,索,塔,台,邰,台,太,泰,谈,覃,谭,澹,檀,镡,汤,唐,棠,陶,腾,提,遆,题,帖,铁,通,仝,同,佟,彤,童,钭,徒,涂,屠,土,脱,完,宛,晚,万,汪,王,望,危,韦,维,蒍,隗,位,尉,温,文,闻,问,翁,瓮,邬,巫,毋,吾,吴,伍,仵,武,务,西,析,郗,息,奚,锡,习,席,袭,隰,舄,夏,先,鲜,咸,冼,洗,羡,线,相,香,襄,祥,向,相,项,肖,萧,孝,谢,渫,辛,忻,新,信,兴,星,刑,邢,行,幸,熊,修,须,顼,徐,许,旭,续,轩,禤,旋,薛,穴,雪,寻,郇,荀,押,牙,轧,鄢,燕,延,严,言,阎,颜,晏,扬,羊,阳,杨,仰,幺,要,尧,姚,铫,药,冶,业,叶,伊,衣,依,仪,宜,乙,蚁,扆,弋,义,亦,易,弈,益,裔,翼,阴,殷,银,尹,印,应,英,营,赢,灜,雍,勇,涌,幽,尤,由,游,於,欲,余,鱼,俞,馀,宇,禹,庾,玉,郁,遇,喻,裕,毓,渊,元,袁,原,圆,源,员,苑,院,乐,岳,悦,越,云,妘,郧,运,员,郓,恽,韵,载,昝,臧,迮,笮,曾,增,查,乍,翟,呰,祭,占,詹,瞻,展,战,湛,张,章,彰,仉,掌,招,召,兆,赵,肇,真,甄,镇,正,郑,政,支,执,直,植,志,郅,智,终,钟,衷,种,仲,周,朱,邾,诸,竹,竺,主,祝,专,庄,卓,禚,资,訾,子,紫,宗,邹,驺,俎,祖,左,韩,安陵,安平,安期,安阳,白马,百里,柏侯,鲍俎,北宫,北郭,北门,北山,北唐,奔水,逼阳,宾牟,薄奚薄野,曹牟,曹丘,常涛,长鱼,车非,成功,成阳,乘马,叱卢,丑门,樗里,穿封,淳子,答禄,达勃,达步,达奚,淡台,邓陵,第五,地连,地伦,东方,东里,东南,东宫,东门东乡,东丹,东郭,东陵,东关,东闾,东阳,东野,东莱,豆卢,斗于,都尉,独孤端木,段干,多子,尔朱,方雷丰将,封人,封父,夫蒙,夫馀,浮丘,傅余,干已,高车,高陵,高堂,高阳,高辛,皋落,哥舒,盖楼,庚桑,梗阳,宫孙,公羊,公良,公孙,公罔,公西,公冶,公敛,公梁,公输,公上,公山,公户,公玉,公仪,公仲公坚,公伯,公祖,公乘,公晰,公族,姑布,古口,古龙,古孙,谷梁,谷浑,瓜田,关龙,鲑阳,归海,函治,韩馀,罕井,浩生,浩星,纥骨,纥奚纥于,贺拨,贺兰,贺楼,赫连,黑齿,黑肱,侯冈,呼延,壶丘,呼衍,斛律,胡非,胡母,胡毋,皇甫,皇父,兀官吉白,即墨,季瓜,季连,季孙,茄众,蒋丘,金齿,晋楚,京城,泾阳,九百,九方,睢鸠,沮渠,巨母,勘阻,渴侯,渴单,可汗,空桐,空相,昆吾,老阳,乐羊,荔菲,栎阳,梁丘,梁由,梁馀,梁垣,陵阳伶舟,冷沦,令狐,刘王,柳下,龙丘,卢妃,卢蒲,鲁步,陆费,角里,闾丘,马矢,麦丘,茅夷,弥牟,密革,密茅,墨夷,墨台,万俊,昌顿,慕容,木门,木易,南宫,南郭,南门,南荣,欧侯,欧阳,逄门,盆成,彭祖,平陵,平宁,破丑,仆固,濮阳,漆雕,奇介,綦母,綦毋,綦连,祁连,乞伏,绮里,千代,千乘,勤宿,青阳,丘丽,丘陵,屈侯,屈突,屈男,屈卢,屈同,屈门,屈引,壤四,扰龙,容成,汝嫣,萨孤,三饭,三闾,三州,桑丘,商瞿,上官,尚方,少师,少施,少室,少叔,少正,社南社北,申屠,申徒,沈犹,胜屠,石作石牛,侍其,士季,士弱,士孙,士贞,叔孙,叔先,叔促,水丘,司城,司空,司寇,司鸿,司马,司徒,司士,似和,素和,夙沙,孙阳,索阳,索卢,沓卢,太史,太叔,太阳,澹台,唐山,堂溪,陶丘,同蹄,统奚,秃发,涂钦,吐火,吐贺,吐万,吐罗,吐门,吐难,吐缶,吐浑吐奚,吐和,屯浑,脱脱,拓拨,完颜,王孙,王官,王人,微生,尾勺,温孤,温稽,闻人,屋户,巫马,吾丘,无庸,无钩,五鹿,息夫,西陵,西乞,西钥,西乡,西门,西周,西郭,西方,西野,西宫,戏阳,瑕吕,霞露,夏侯,鲜虞,鲜于,鲜阳,咸丘,相里,解枇,谢丘,新垣,辛垣,信都,信平,修鱼,徐吾,宣于,轩辕,轩丘,阏氏,延陵,罔法,铅陵,羊角,耶律,叶阳,伊祁,伊耆,猗卢,义渠,邑由,因孙,银齿,尹文,雍门,游水,由吾,右师,宥连,於陵,虞丘,盂丘,宇文,尉迟,乐羊,乐正,运奄,运期,宰父,辗迟,湛卢,章仇,仉督,长孙,长儿,真鄂,正令,执头,中央,中长,中行,中野,中英,中梁,中垒,钟离,钟吾,终黎,终葵,仲孙,仲长,周阳,周氏,周生,朱阳,诸葛,主父,颛孙,颛顼,訾辱,淄丘,子言,子人,子服子家,子桑,子叔,子车,子阳,宗伯,宗正,宗政,尊卢,昨和,左人,左丘,左师,左行,刘文,额尔,达力,蔡斯,浩赏,斛斯,夹谷,揭阳,万俟,淳于,单于,徐离";', '2010-11-25 09:33:01'),
(72, 0, 'inviteset', 'invite_set', 's:6:"common";', '2012-07-11 10:27:42'),
(61, 0, 'siteopt', 'site_theme', 's:8:"newstyle";', '2012-07-11 10:27:23'),
(19, 0, 'inviteset', '__hash__', 's:32:"de6fa0dbb82ebd33d9d824d757332c1e";', '2010-11-26 03:51:05'),
(20, 0, 'default', 'default', '15', '2010-11-19 03:57:11'),
(55, 0, 'siteopt', 'site_closed_reason', 's:0:"";', '2012-07-11 10:27:23'),
(51, 0, 'siteopt', 'site_header_keywords', 's:29:"ThinkSNS、开源微博系统";', '2012-07-11 10:27:23'),
(52, 0, 'siteopt', 'site_header_description', 's:26:"ThinkSNS开源微博系统";', '2012-07-11 10:27:23'),
(53, 0, 'siteopt', 'site_icp', 's:57:"智士软件（北京）有限公司 京ICP备04000001号";', '2012-07-11 10:27:23'),
(56, 0, 'siteopt', 'site_anonymous', 's:1:"1";', '2012-07-11 10:27:23'),
(57, 0, 'siteopt', 'site_anonymous_square', 's:1:"1";', '2012-07-11 10:27:23'),
(58, 0, 'siteopt', 'site_anonymous_search', 's:1:"0";', '2012-07-11 10:27:23'),
(28, 0, 'siteopt', 'site_appalias_wordwrap', 's:1:"1";', '2010-11-29 09:40:14'),
(83, 0, 'attach', 'attach_path_rule', 's:7:"Y/md/H/";', '2012-07-11 10:28:51'),
(84, 0, 'attach', 'attach_max_size', 'd:2;', '2012-07-11 10:28:51'),
(85, 0, 'attach', 'attach_allow_extension', 's:59:"jpg,gif,png,jpeg,bmp,zip,rar,doc,xls,ppt,docx,xlsx,pptx,pdf";', '2012-07-11 10:28:51'),
(32, 0, 'attach', '__hash__', 's:32:"3d1ba92bca03cacb92bb32379f880356";', '2010-11-29 09:41:15'),
(73, 0, 'announcement', 'is_open', 'i:1;', '2012-07-11 10:28:00'),
(74, 0, 'announcement', 'content', 's:38:"欢迎使用ThinkSNS开源微博系统";', '2012-07-11 10:28:00'),
(35, 0, 'addons_weibo_type', 'image', 'a:3:{s:5:"limit";i:10;s:4:"size";i:2048;s:3:"ext";s:17:"jpg;gif;png;jpeg;";}', '2012-04-22 07:03:09'),
(36, 0, 'addons_space_app_show', 'open', 'a:4:{i:0;s:5:"photo";i:1;s:4:"blog";i:2;s:5:"group";i:3;s:4:"vote";}', '2012-04-22 07:01:58'),
(123, 0, 'addons_short_url', 'sinakey', 's:0:"";', '2012-07-11 10:38:04'),
(124, 0, 'addons_short_url', 'googlekey', 's:0:"";', '2012-07-11 10:38:04'),
(126, 0, 'addons_short_url', 'shorturlapi', 's:5:"baidu";', '2012-07-11 10:38:04'),
(127, 0, 'addons_short_url', 'localurl', 's:0:"";', '2012-07-11 10:38:04'),
(41, 0, 'addons_square_app_show', 'photo', 'i:0;', '2012-04-22 07:03:44'),
(42, 0, 'addons_square_app_show', 'blog', 'i:0;', '2012-04-22 07:03:44'),
(43, 0, 'addons_square_app_show', 'group', 'i:0;', '2012-04-22 07:03:44'),
(44, 0, 'addons_visitor', 'open', 'a:1:{i:0;s:5:"space";}', '2012-04-22 07:02:55'),
(45, 0, 'addons_visitor', 'limit', 's:1:"6";', '2012-04-22 07:02:55'),
(46, 0, 'addons_weibo_type', 'open', 'a:3:{i:0;s:1:"1";i:1;s:1:"3";i:2;s:1:"4";}', '2012-04-22 07:03:09'),
(47, 0, 'addons_weibo_type', 'file', 'a:2:{s:4:"size";i:2048;s:3:"ext";s:59:"jpg;gif;png;jpeg;bmp;zip;rar;doc;xls;ppt;docx;xlsx;pptx;pdf";}', '2012-04-22 07:01:27'),
(50, 0, 'siteopt', 'site_header_title', 's:26:"ThinkSNS开源微博系统";', '2012-07-11 10:27:23'),
(60, 0, 'siteopt', 'site_rewrite_on', 's:1:"0";', '2012-07-11 10:27:23'),
(64, 0, 'siteopt', 'length', 's:3:"140";', '2012-07-11 10:27:23'),
(65, 0, 'siteopt', 'max_post_time', 's:1:"5";', '2012-07-11 10:27:23'),
(66, 0, 'siteopt', 'max_following', 's:4:"1000";', '2012-07-11 10:27:23'),
(67, 0, 'siteopt', 'max_search_time', 's:1:"5";', '2012-07-11 10:27:23'),
(86, 0, 'attach', 'attach_watermark_closed', 's:1:"0";', '2012-07-11 10:28:51'),
(87, 0, 'attach', 'attach_watermark_minwidth', 's:3:"200";', '2012-07-11 10:28:51'),
(88, 0, 'attach', 'attach_watermark_minheight', 's:3:"200";', '2012-07-11 10:28:51'),
(89, 0, 'attach', 'attach_watermark_txt', 's:8:"@{uname}";', '2012-07-11 10:28:51'),
(90, 0, 'attach', 'attach_watermark_fontsize', 's:2:"12";', '2012-07-11 10:28:51'),
(101, 0, 'top_follower', 'hide_no_avatar', 'i:0;', '2012-07-11 10:30:23'),
(102, 0, 'top_follower', 'hide_auto_friend', 'i:1;', '2012-07-11 10:30:23'),
(103, 0, 'weibo', 'todaytopic', 's:6:"签到";', '2012-07-11 10:32:10'),
(104, 0, 'weibo', 'openAutoDenounce', 's:1:"0";', '2012-07-11 10:32:10'),
(105, 0, 'weibo', 'hotTopicTime', 's:1:"7";', '2012-07-11 10:32:10'),
(106, 0, 'weibo', 'hotTopic', 'a:0:{}', '2012-07-11 10:32:10'),
(107, 0, 'weibo', 'hotTopicNote', 'a:0:{}', '2012-07-11 10:32:10'),
(108, 0, 'square', 'hotuser', 's:1:"1";', '2012-07-11 10:32:23'),
(109, 0, 'square', 'transpond', 's:1:"7";', '2012-07-11 10:32:23'),
(110, 0, 'square', 'comment', 's:1:"7";', '2012-07-11 10:32:23'),
(117, 0, 'addons_related_user', 'hide_no_avatar', 's:1:"1";', '2012-07-11 10:34:33'),
(118, 0, 'addons_related_user', 'tag_weight', 's:1:"5";', '2012-07-11 10:34:33'),
(119, 0, 'addons_related_user', 'city_weight', 's:1:"5";', '2012-07-11 10:34:33'),
(120, 0, 'addons_related_user', 'friend_weight', 's:2:"10";', '2012-07-11 10:34:33'),
(121, 0, 'addons_related_user', 'follower_weight', 's:2:"10";', '2012-07-11 10:34:33'),
(122, 0, 'addons_related_user', 'total_weight', 'i:30;', '2012-07-11 10:34:33'),
(125, 0, 'addons_short_url', 'neteasekey', 's:0:"";', '2012-07-11 10:38:04');
